$(document).ready(function() {

    var exc,

        ExceptionsTab = {
            settings: {
                buttons: {
                    add: '#exception_add_button',
                    edit: '.iu_exception_edit',
                    remove: '.iu_exception_delete',
                    add_number: '#add_numbers_button',
                    number_update: '#numbers_update_button',
                    number_del: 'button[data-bind="del-number"].iu-icon-delete-user',
                    number_del_update: 'button[data-bind="del-number-update"].iu-icon-delete-user-update'
                },
                observer_title: "",
                observer_title_update: "",
                observer_data_id: ""
            },

            init: function () {
                exc = this;
                this.bindUIActions();
                this.hideShowTab();
                
            },

            /**
             * обработчики кнопок
             */
            bindUIActions: function() {
                var s = this;
                $(document.body).on('click', exc.settings.buttons.add, function() {
                    var buttons = [];
                    
                    buttons['Submit'] = iub24.lang[currentLocale]['Submit'];
                    buttons['Cancel'] = iub24.lang[currentLocale]['Cancel'];

                    var buttonArray = {};
                    buttonArray[buttons['Submit']] = function() {
                        exc.create();
                        $(this).dialog("close");
                        
                    };
                    buttonArray[buttons['Cancel']] = function() {
                        $(this).dialog('close');
                    };
                    //$('.numbers_observers').selectize();
                    $("#add_exception").dialog({
                        resizable: false,
                        height: "auto",
                        width: 800,
                        modal: true,
                        buttons: buttonArray
                    });

                });

                /**
                 * Добавление номеров при изменении исключения
                 */
                $(document.body).on('click', exc.settings.buttons.number_update, function() {
                    
                    
                    var addUp = $(this).closest("div.form-group").find("div.numb_update");
                    var self = $(this);
                    
                    $(this).closest("div.form-group").find('select.selectized').each(function(){ // do this for every select with the 'combobox' class
                        console.log('sdfsd');
                        if ($(this)[0].selectize) { // requires [0] to select the proper object
                            var value = $(this).val(); // store the current value of the select/input
                            $(this)[0].selectize.destroy(); // destroys selectize()
                            $(this).val(value);  // set back the value of the select/input
                        }
                    });

                    addUp.before('<div class="col-md-3" data-observ="numbers-update-add">' +
                        '<button type="button" data-bind="del-number-update" class="ui-button ui-widget ui-state-default ui-corner-all ui-button-icon-only ui-dialog-titlebar-close iu-icon-delete-user-update margin-style-delete" role="button">' +
                        '<span class="ui-button-icon-primary ui-icon ui-icon-closethick"></span>' +
                        '</button></div><div class="col-md-9" data-observ="numbers-update-add">' +
                        $('.col-md-9[data-observ="numbers-update-add"]:first').clone().html() +
                        '</div>');
                    
                    $(exc.settings.buttons.number_del_update).removeClass("hidden");

                    $(this).closest("div.form-group").find('select[name="numbers[]"]').selectize({
                        create: false,
                        sortField: 'text'
                    });
                    
                });

                /**
                 * Удаление наблюдателей при изменении исключения
                 */
                $(document.body).on('click', exc.settings.buttons.number_del_update, function() {
                    var self = this;
                    
                    if ($("#update_exception").find(".col-md-9[data-observ='numbers-update-add']").length > 1) {
                        
                        $(self).closest(".col-md-3").next().remove();
                        $(self).parent().remove();

                        var observTitle = $("#update_exception").find("label[data-name='numbers_update']").text();

                        if (observTitle.length < 1) {
                            $('.col-md-9[data-observ="numbers-update-add"]:first').prev().prepend('<label class="control-label" for="observers" data-name="observers_update">' +
                                exc.settings.observer_title_update +
                                '</label>');
                            $('.col-md-9[data-observ="numbers-update-add"]:first').prev().find(exc.settings.buttons.number_del_update)
                                .removeClass("margin-style-delete").addClass("margin-style-delete-main");
                        }
                    }

                    if ($("#update_exception").find(".col-md-9[data-observ='numbers-update-add']").length == 1) {
                        $(exc.settings.buttons.number_del_update).addClass("hidden");
                    }
                });

                /**
                 * Добавление наблюдателей при добавлении задачи
                 */
                $(document.body).on('click', exc.settings.buttons.add_number, function() {
                    
                    $('.numbers_observers').each(function(){ // do this for every select with the 'combobox' class
                        if ($(this)[0].selectize) { // requires [0] to select the proper object
                            var value = $(this).val(); // store the current value of the select/input
                            $(this)[0].selectize.destroy(); // destroys selectize()
                            $(this).val(value);  // set back the value of the select/input
                        }
                    });
                    
                    $('#add_number_exc').before('<div class="col-md-3"><button type="button" data-bind="del-number" class="ui-button ui-widget ui-state-default ui-corner-all ui-button-icon-only ui-dialog-titlebar-close iu-icon-delete-user margin-style-delete" role="button">' +
                        '<span class="ui-button-icon-primary ui-icon ui-icon-closethick"></span>' +
                        '</button></div><div class="col-md-9" data-observ="numbers-list">' +
                        $('div[data-observ="numbers-list"]:first').clone().html() +
                        '</div>');


                    $('button[data-bind="del-number"].iu-icon-delete-user').removeClass("hidden");

                    $('select.numbers_observers').selectize({
                        create: false,
                        sortField: 'text'
                    });
                });

                $(document.body).on('click', exc.settings.buttons.number_del, function() {
                    var self = this;

                    if ($("#add_exception").find(".col-md-9[data-observ='numbers-list']").length > 1) {

                        $(self).closest(".col-md-3").next().remove();
                        $(self).parent().remove();

                        var observTitle = $("#add_exception").find("label[data-name='numbers']").text();

                        if (observTitle.length < 1) {
                            $('div[data-observ="numbers-list"]:first').prev().prepend('<label class="control-label" for="numbers" data-name="numbers">' +
                                exc.settings.observer_title +
                                '</label>');
                            $('div[data-observ="numbers-list"]:first').prev().find('button[data-bind="del-number"].iu-icon-delete-user')
                                .removeClass("margin-style-delete").addClass("margin-style-delete-main");
                        }
                    }

                    if ($("#add_exception").find(".col-md-9[data-observ='numbers-list']").length == 1) {
                        $('button[data-bind="del-number"].iu-icon-delete-user').addClass("hidden");
                    }
                });

                $(document.body).on('click', exc.settings.buttons.edit, function() {
                    var self = this;
                    var $id = $(self).attr('data-exception-id');
                    var $editDialog = $('#update_exception');
                    $editDialog.find('div[data-clear="numb-clear"]').remove();
                    $editDialog.find('div[data-observ="numbers-update-add"]').remove();
                    var promise = exc.detail($id);

                    promise.done(function(res) {
                        $editDialog.find('.update_exception_form').attr('data-exception-id', res.id);
                        $editDialog.find('#description').val(res.description);
                        
                        var numbers = res.numbers.split('|').reverse();
                        var countNumb = numbers.length;
                        for(i in numbers) {
                            var label = i == countNumb-1 ? res.label : '';
                            $editDialog.find('div[data-name="update_observ_num"]').prepend(s.renderNumbersBlock(numbers[i], label, res.users));
                        }
                        
                        exc.settings.observer_title_update = $editDialog.find("label[data-name='observers_update']").text();
                        
                        var buttons = [];
                        buttons['Update'] = iub24.lang[currentLocale]['Update'];
                        buttons['Cancel'] = iub24.lang[currentLocale]['Cancel'];

                        var $selectize = $('[data-name="update_observ_num"] select').selectize({
                            create: false,
                            sortField: 'text'
                        });

                        var buttonArray = {};
                        buttonArray[buttons['Update']] = function() {
                            exc.update();
                            $(this).dialog("close");
                        };
                        buttonArray[buttons['Cancel']] = function() {
                            $(this).dialog('close');
                        };

                        $('button[data-bind="del-number-update"].iu-icon-delete-user-update').removeClass("hidden");
                        $('#update_exception').dialog({
                            resizable: false,
                            height: "auto",
                            width: 900,
                            modal: true,
                            buttons: buttonArray
                        });
                    });

                });

                $(document.body).on('click', exc.settings.buttons.remove, function() {
                    
                    exc.remove(this);
                    
                });

            },

            /**
             * Строим верстку по выбор/изменение номеров
             * текстовых полей
             * @param array numbers 
             */
            renderNumbersBlock: function(number, label, listUsers){
                
                var $template = '<div class="col-md-3" data-clear="numb-clear" data-observ="numbers-update-add">'+
                    '<label class="control-label" for="numbers" data-name="numbers">'+label+'</label>'+
                    '<button type="button" data-bind="del-number-update" class="ui-button ui-widget ui-state-default ui-corner-all ui-button-icon-only ui-dialog-titlebar-close iu-icon-delete-user-update hidden margin-style-delete-main" role="button">'+
                        '<span class="ui-button-icon-primary ui-icon ui-icon-closethick"></span>'+
                    '</button>'+
                '</div>'+
                '<div class="col-md-9" data-observ="numbers-update-add" data-clear="numb-clear">'+
                    '<select class="form-control" name="numbers[]">'; 
                    for(var i in listUsers) {
                        var selected = listUsers[i]['ID'] == number ? 'selected' : '';
                        $template += '<option '+selected+' value="'+listUsers[i]['ID']+'">'+listUsers[i]['LAST_NAME']+' '+listUsers[i]['NAME']+'</option>';
                    }
                    $template += '</select>'+
                '</div>';
                
                
                return $template;
            },

            /**
             * создание новой задачи
             */
            create: function() {
                var self = this;
                var numbers = [];

                var numbers = $('#add_exception select[name="numbers[]"]').map(function(idx, elem) {
                    return $(elem).val();
                }).get();

                $.ajax({
                    url: window.ajaxurl,
                    type: "POST",
                    data: {
                        command: 'create_exception_item',
                        module: window.modulename,
                        desc: $('#add_exception').find('input[name=description]').val(),
                        numbers: numbers.join('|'),
                        
                    },
                    success: function(data) {
                        fpbxToast('Created new exception', 'Created new exception', 'success');
                        document.location.reload();
                    }
                });
            },

            /**
             * изменение задачи
             */
            update: function() {

                
                var numbers = [];

                var numbers = $('#update_exception select[name="numbers[]"]').map(function(idx, elem) {
                    return $(elem).val();
                }).get();
                

                $.ajax({
                    url: window.ajaxurl,
                    type: "POST",
                    data: {
                        command: 'update_exception_item',
                        module: window.modulename,
                        id: $('#update_exception').find('.update_exception_form').attr('data-exception-id'),
                        desc: $('#update_exception').find('input[name=description]').val(),
                        numbers: numbers.join('|'),
                    },
                    success: function(data) {
                        fpbxToast('Complete', 'Update exception', 'success');
                        document.location.reload();
                    }
                });
            },

            /**
             * удаление задачи
             * @param ob
             */
            remove: function(ob) {
                $.ajax({
                    url: window.ajaxurl,
                    type: "POST",
                    data: {
                        command: 'remove_exception_item',
                        module: window.modulename,
                        id: $(ob).attr('data-exception-id')
                    },
                    success: function(data) {
                        fpbxToast('Complete delete', 'Remove task', 'success');
                        document.location.reload();
                    }
                });
            },

            /**
             * получение детальной информации о задаче по ее id
             * @param id
             * @returns {*}
             */
            detail: function(id) {
                var self = this;
                var deferred = $.Deferred();
                var exception = null;

                $.ajax({
                    url: window.ajaxurl,
                    type: "POST",
                    data: {
                        command: 'get_exception_item',
                        module: window.modulename,
                        id: id
                    },
                    success: function(data) {
                        exception = data;
                    },
                    complete: function() {
                        deferred.resolve(exception);
                    }
                });

                return deferred.promise();
            },

            hideShowTab: function() {
                if ($('label[for=activatedyes]').length) {
                    $('li[data-name=exceptions]').hide();
                }
            }
        };

    ExceptionsTab.init();
});