$(document).ready(function () {
    var externalCall,
        ExternallCallHandlers = {
            settings: {
                buttons: {
                    register: '#click_call_reg'
                }
            },

            init: function() {
                externalCall = this;
                this.bindUIActions();
                this.hideShowTab();
            },

            bindUIActions: function() {
                var self = this;
                $(document.body).on('click', externalCall.settings.buttons.register, function () {
                    self.register();
                });
            },

            register: function() {
                $.ajax({
                    url: window.ajaxurl,
                    type: "POST",
                    data: {
                        command: 'registerClickCall',
                        module: window.modulename
                    },
                    success: function (data) {
                        fpbxToast('Complete', 'Register', 'success');
                        document.location.reload();
                    }
                });
            },

            hideShowTab: function() {
                if($('label[for=activatedyes]').length) {
                    $('li[data-name=callback_handlers]').hide();
                }
            },
        };

    ExternallCallHandlers.init();

});