$(document).ready(function() {

    if ($('select.user_id').length) {
        var $selectize = $('.user_id').selectize({
            create: false,
            sortField: 'text'
        });
    }

    var s,
        InboundDestinationTab = {
            settings: {
                buttons: {
                    add: '#inbound_dest_add',
                    edit: '.iu_edit',
                    remove: '.iu_delete'
                }
            },

            init: function() {
                s = this;
                this.bindUIActions();
                this.hideShowTab();
            },

            /**
             * обработчики кнопок
             */
            bindUIActions: function() {
                $(document.body).on('click', s.settings.buttons.add, function() {
                    //var $editDialog = $('#update_inbound');
                    //$editDialog.empty();
                    var buttons = [];
                    buttons['Submit'] = iub24.lang[currentLocale]['Submit'];
                    buttons['Cancel'] = iub24.lang[currentLocale]['Cancel'];

                    var buttonArray = {};
                    buttonArray[buttons['Submit']] = function() {
                        if(s.__checkInvalid($('#add_inbound'))) {
                            s.create();
                            $(this).dialog("close");
                        }
                    };
                    buttonArray[buttons['Cancel']] = function() {
                        $(this).dialog('close');
                    };

                    $("#add_inbound").dialog({
                        resizable: false,
                        height: "auto",
                        width: 900,
                        modal: true,
                        buttons:buttonArray
                    });

                });
                //
                // $(document.body).on('change', 'select[name=dest_inbound_b24]', function(e) {
                //     if ($(this).val() == 'add_news_inbound') {
                //         var buttons = [];
                //         buttons['Submit'] = iub24.lang[currentLocale]['Submit'];
                //         buttons['Cancel'] = iub24.lang[currentLocale]['Cancel'];
                //
                //         var buttonArray = {};
                //         buttonArray[buttons['Submit']] = function() {
                //             if(s.__checkInvalid($('#add_inbound'))) {
                //                 s.create();
                //                 $(this).dialog("close");
                //             }
                //         };
                //         buttonArray[buttons['Cancel']] = function() {
                //             $(this).dialog('close');
                //         };
                //         $("#add_inbound").dialog({
                //             resizable: false,
                //             height: "auto",
                //             width: 900,
                //             modal: true,
                //             buttons: buttonArray
                //         });
                //     }
                // });

                $(document.body).on('click', s.settings.buttons.edit, function() {
                    var self = this;
                    var $id = $(self).attr('data-did-id');
                    //var $dialog = $( "#add_inbound" ).clone();
                    var $editDialog = $('#update_inbound');
                    //$editDialog.empty();
                    //$editDialog.html($dialog);

                    var promise = s.detail($id);
                    promise.done(function(res) {
                        console.log('detail ', res);
                        $editDialog.find('.update_did_form').attr('data-did-id', res.id);
                        $editDialog.find('input[name=description]').val(res.description);
                        $editDialog.find('input[name=callrecording_mode][value=' + res.assassement + ']').prop('checked', true);
                        //$editDialog.find('input[name=consider_manager][value=' + res.manager_in_cahrge + ']').prop('checked', true);
                        $editDialog.find('input[name=show_caller_name][value=' + res.show_caller_name + ']').prop('checked', true);
                        $editDialog.find('input[name=show_card][value=' + res.show_card + ']').prop('checked', true);
                        $editDialog.find('input[name=add_to_chat][value=' + res.add_to_chat + ']').prop('checked', true);
                        $editDialog.find('input[name=assign][value=' + res.assign + ']').prop('checked', true);
                        $editDialog.find('input[name=assigned_manager_ring_timer]').val(res.assigned_manager_ring_timer);
                        $editDialog.find('input[name=create_lead][value=' + res.create_lead + ']').prop('checked', true);
                        $editDialog.find('select[name=source]').val(res.source);
                        $editDialog.find('select[name=did_tasks]').val(res.task);

                        $editDialog.find('select[name=exclusions]').val(res.exception);

                        //$editDialog.find('select[name=user_id]').val(res.user_id);
                        /*$editDialog.find(".user_id").selectize({
                            create: false,
                            sortField: 'text'
                        });*/

                        if($selectize == 'undefined') {
                            $selectize[0].selectize.setValue(res.user_id);
                        }

                        if (res.manager_in_cahrge == 'manager_in_charge,exten' || res.manager_in_cahrge == 'manager_in_charge,mobile') {
                            $('.show_div_ringtimer').show();
                        }
                        if (res.assassement == 'yes') {
                            $editDialog.find('.show_div_greet').show();
                            $editDialog.find('select[name=greatings]').val(res.greatings);
                        }

                        if (res.assassement == 'yes') {
                            $editDialog.find('.show_div_bye').show();
                            $editDialog.find('select[name=bye]').val(res.bye);
                        }
                        var buttons = [];
                        buttons['Update'] = iub24.lang[currentLocale]['Update'];
                        buttons['Cancel'] = iub24.lang[currentLocale]['Cancel'];

                        var buttonArray = {};
                        buttonArray[buttons['Update']] = function() {
                            if(s.__checkInvalid($('#update_inbound'))) {
                                s.update();
                                $(this).dialog("close");
                            }
                        };
                        buttonArray[buttons['Cancel']] = function() {
                            $(this).dialog('close');
                        };
                        $('#update_inbound select[name=Assigned_Manager1], ' +
                            '' +
                            '#update_inbound select[name=goto1]').on('change', function() {
                            switch ($(this).val()) {

                                case 'manager_in_charge,exten':
                                case 'manager_in_charge,mobile':

                                    $('.show_div_ringtimer').show();
                                    break;
                                default:


                                    $('.show_div_ringtimer').hide();

                                    break;
                            }
                        });

                        $("#update_inbound").dialog({
                            resizable: false,
                            height: "auto",
                            width: 900,
                            modal: true,
                            buttons: buttonArray
                        });
                    });

                });

                $(document.body).on('click', s.settings.buttons.remove, function() {
                    var self = this;
                    $("#delete_inbound").dialog({
                        resizable: false,
                        height: "auto",
                        width: 600,
                        modal: true,
                        buttons: {
                            "Remove": function() {
                                s.remove(self);
                                $(this).dialog("close");
                            },
                            Cancel: function() {
                                $(this).dialog("close");
                            }
                        }
                    });
                });

                $('#add_inbound select[name=Assigned_Manager1]').on('change', function() {
                    switch ($('#add_inbound select[name=Assigned_Manager1]').val()) {
                        case 'manager_in_charge,exten':
                        case 'manager_in_charge,mobile':
                            $('.show_div_ringtimer').show();
                            break;
                        default:
                            $('.show_div_ringtimer').hide();

                            break;
                    }
                });
                $('#add_inbound select[name=goto1]').on('change', function() {
                    switch ($(this).find().val()) {
                        case 'manager_in_charge,exten':
                        case 'manager_in_charge,mobile':
                            $('.show_div_ringtimer').show();
                            break;
                        default:
                            $('.show_div_ringtimer').hide();

                            break;
                    }
                });
                $('#add_inbound input[name=callrecording_mode], ' +
                    '#update_inbound input[name=callrecording_mode]').on('change', function() {
                    //var $form = $(this).closest('.dialog-form-module');

                    switch ($(this).val()) {
                        case 'yes':

                            $('.show_div_greet').show();
                            $('.show_div_bye').show();
                            break;
                        case 'no':


                            $('.show_div_greet').hide();
                            $('.show_div_bye').hide();
                            break;
                    }
                });

            },

            /**
             * создание нового дида
             */
            create: function() {
                var self = this;
                $.ajax({
                    url: window.ajaxurl,
                    type: "POST",
                    data: {
                        command: 'create_inbound_did',
                        module: window.modulename,
                        description: $('#add_inbound').find('input[name=description]').val(),
                        assasement: $('#add_inbound').find('input[name=callrecording_mode]:checked').val(),
                        great: $('#add_inbound').find('#greatings').val(),
                        bye: $('#add_inbound').find('#bye').val(),
                        manager: s.getDestinationForm($('#add_inbound'), '.consider_manager'),
                        assigned_manager_ring_timer: $('#add_inbound').find('input[name=assigned_manager_ring_timer]').val(),
                        destination: s.getDestinationForm($('#add_inbound')),
                        source: $('#add_inbound').find('#source').val(),
                        user_id: $('#add_inbound').find('select[name=user_id]').val(),
                        show_caller_name: $('#add_inbound').find('input[name="show_caller_name"]:checked').val(),
                        assign: $('#add_inbound').find('input[name="assign"]:checked').val(),
                        show_card: $('#add_inbound').find('input[name="show_card"]:checked').val(),
                        create_lead: $('#add_inbound').find('input[name="create_lead"]:checked').val(),
                        add_to_chat: $('#add_inbound').find('input[name="add_to_chat"]:checked').val(),
                        task_id: $('#add_inbound').find('#did_tasks').val(),
                        exception: $('#add_inbound').find('select[name=exclusions]').val()
                    },
                    success: function(data) {
                        fpbxToast('Complete', 'Created did', 'success');
                        document.location.reload();
                    }
                });
            },

            /**
             * обновление дида
             */
            update: function() {
                $.ajax({
                    url: window.ajaxurl,
                    type: "POST",
                    data: {
                        command: 'update_inbound_did',
                        module: window.modulename,
                        id: $('#update_inbound').find('.update_did_form').attr('data-did-id'),
                        description: $('#update_inbound').find('input[name=description]').val(),
                        assasement: $('#update_inbound').find('input[name=callrecording_mode]:checked').val(),
                        great: $('#update_inbound').find('#greatings').val(),
                        bye: $('#update_inbound').find('#bye').val(),
                        manager: s.getDestinationForm($('#update_inbound'), '.consider_manager'),
                        destination: s.getDestinationForm($('#update_inbound')),
                        source: $('#update_inbound').find('#source').val(),
                        user_id: $('#update_inbound').find('.user_id').val(),
                        show_caller_name: $('#update_inbound').find('input[name="show_caller_name"]:checked').val(),
                        show_card: $('#update_inbound').find('input[name="show_card"]:checked').val(),
                        assign: $('#update_inbound').find('input[name="assign"]:checked').val(),
                        create_lead: $('#update_inbound').find('input[name="create_lead"]:checked').val(),
                        add_to_chat: $('#update_inbound').find('input[name="add_to_chat"]:checked').val(),
                        task_id: $('#update_inbound').find('#did_tasks').val(),
                        assigned_manager_ring_timer: $('#update_inbound').find('input[name=assigned_manager_ring_timer]').val(),
                        exception: $('#update_inbound').find('select[name=exclusions]').val()
                    },
                    success: function(data) {
                        fpbxToast('Complete', 'Update did', 'success');
                        document.location.reload();
                    }
                });
            },

            /**
             * удаление дида
             * @param ob
             */
            remove: function(ob) {
                $.ajax({
                    url: window.ajaxurl,
                    type: "POST",
                    data: {
                        command: 'remove_inbound_did',
                        module: window.modulename,
                        id: $(ob).attr('data-did-id')
                    },
                    success: function(data) {
                        fpbxToast('Complete', 'Removing did', 'success');
                        document.location.reload();
                    }
                });
            },

            /**
             * получение детальной информации о диде по его id
             * @param id
             * @returns {*}
             */
            detail: function(id) {
                var self = this;
                var deferred = $.Deferred();
                var did = null;

                $.ajax({
                    url: window.ajaxurl,
                    type: "POST",
                    data: {
                        command: 'get_inbound_did',
                        module: window.modulename,
                        id: id
                    },
                    success: function(data) {
                        console.log(data);
                        did = data;
                        if (data['destination_custom']) {
                            self.getDestination('.dest_ajax', data['destination_custom']);
                            self.getDestination('.manager_ajax', data['consider_manager_custom']);
                        }
                        bind_dests_double_selects();
                    },
                    complete: function() {
                        deferred.resolve(did);
                    }
                });

                return deferred.promise();
            },

            getDestination: function(className, html) {

                $('#update_inbound').find(className).html(html);
            },

            clearForm: function() {
                $('#add_inbound').find('input[name=description]').val('');
            },

            hideShowTab: function() {
                if ($('label[for=activatedyes]').length) {
                    $('li[data-name=inbound_destinations]').hide();
                }
            },

            /**
             * Получаем destination route из селектов
             * в настройках
             * @returns {*}
             */
            getDestinationForm: function($form, className) {
                var className = typeof className == 'undefined' ? '.dest_settings_b24' : className;
                var destination = null;
                $.each($form.find(className + ':visible'), function() {
                    var attr = $(this).attr('data-class');
                        destination = $(this).val();
                });

                return destination;
            },
            __checkInvalid: function($form) {
                var description = $form.find('input[name="description"]');
                var user_id = $form.find('select[name=user_id]');
                var show_card = $form.find('input[name="show_card"]');
                var create_lead = $form.find('input[name="create_lead"]');
                var div_ring_timer = $form.find('.show_div_ringtimer');

                if (!description.val()){
                    warnInvalid(description);
                    return false;
                }
                if (!user_id.val()){
                    warnInvalid(user_id);
                    return false;
                }
                if (!show_card.is(':checked')){
                    warnInvalid(show_card);
                    return false;
                }
                if (!create_lead.is(':checked')){
                    warnInvalid(create_lead);
                    return false;
                }
                if((div_ring_timer.is(':visible')  && !div_ring_timer.find('input[name="assigned_manager_ring_timer"]').val()) || (div_ring_timer.is(':visible')  && div_ring_timer.find('input[name="assigned_manager_ring_timer"]').val() < 1)){
                    warnInvalid(div_ring_timer);
                    return false;
                }
                return true;
            },


        };

    InboundDestinationTab.init();

});