$(document).ready(function () {

    var externalCallBack,
        ExternallCallBackHandlers = {
            settings: {
                buttons: {
                    register: '#click_back_reg'
                }
            },

            init: function() {
                externalCallBack = this;
                this.bindUIActions();
            },

            bindUIActions: function() {
                var self = this;
                $(document.body).on('click', externalCallBack.settings.buttons.register, function () {
                    self.register();
                });
            },

            register: function() {
                $.ajax({
                    url: window.ajaxurl,
                    type: "POST",
                    data: {
                        command: 'registerClickBackCall',
                        module: window.modulename
                    },
                    success: function (data) {
                        fpbxToast('Complete', 'Register', 'success');
                        document.location.reload();
                    }
                });
            }
        };

    ExternallCallBackHandlers.init();

});