<div class="container-fluid">
    <div class="row">
        <div class="col-sm-2">
            <h1 style="margin-bottom:0px;">InformUnity.Bitrix24</h1>
            <h6 class="pull-left">Ver:<?php echo _($version)?><h6>
        </div>
        <div class="col-sm-1 pull-right">
            <a target="_blank" href="https://www.bitrix24.<?php echo _('com')?>/apps/?app=informunity.fpbx#install" class="pull-right">
                <i class="glyphicon glyphicon-question-sign" style="font-size: 25px;"></i>
            </a>
        </div>
    </div>
    <div class="row">
        <div class="col-sm-12">
            <div class="fpbx-container">
                <div class="display no-border">
                    <form id="iu_main_form" class="fpbx-submit" autocomplete="off" method="post">
                        <?php
                            if(isset($config['license'])) {
                        ?>
                        <div value="<?php echo $config['license']?>" class="hidden license"></div>
                        <?php
                        }
                        ?>
                        <div value="<?php echo $config['client_id']?>" class="hidden app_id"></div>
                        <div class="nav-container">
                            <div class="scroller scroller-left"><i class="glyphicon glyphicon-chevron-left"
                                                                   style="display: none;"></i></div>
                            <div class="scroller scroller-right"><i class="glyphicon glyphicon-chevron-right"
                                                                    style="display: inline;"></i></div>
                            <div class="wrapper">
                                <ul class="nav nav-tabs list" role="tablist">
                                    <li role="presentation" data-name="settings" class="active">
                                        <a href="#settings" aria-controls="settings" role="tab" data-toggle="tab"><?php echo _("Registration Data")?></a>
                                    </li>

                                    <li role="presentation" data-name="callback_handlers">
                                        <a href="#callback_handlers" aria-controls="callback_handlers" role="tab" data-toggle="tab"><?php echo _("Bitrix 24 Handlers")?> </a>
                                    </li>
                                    <li role="presentation" data-name="lines_tab">
                                        <a href="#lines_tab" aria-controls="lines_tab" role="tab" data-toggle="tab"><?php echo _("Lines")?> </a>
                                    </li>
                                    <li role="presentation" data-name="tasks">
                                        <a href="#tasks" aria-controls="tasks" role="tab" data-toggle="tab"><?php echo _("Tasks")?> </a>
                                    </li>
                                    <li role="presentation" data-name="inbound_destinations">
                                        <a href="#inbound_destinations" aria-controls="inbound_destinations" role="tab" data-toggle="tab"><?php echo _("Inbound Destinations")?> </a>
                                    </li>
                                    <li role="presentation" data-name="outbound_routes">
                                        <a href="#outbound_routes" aria-controls="outbound_routes" role="tab" data-toggle="tab"><?php echo _("Outbound Routes")?> </a>
                                    </li>
                                    <li role="presentation" data-name="advanced_settings">
                                        <a href="#advanced_settings" aria-controls="advanced_settings" role="tab" data-toggle="tab"><?php echo _("Advanced")?> </a>
                                    </li>

                                    <li role="presentation" data-name="exceptions">
                                        <a href="#exceptions" aria-controls="exceptions" role="tab" data-toggle="tab"><?php echo _("Exceptions")?></a>
                                    </li>
                                    
                                </ul>
                            </div>
                        </div>
                        <div class="tab-content display">
                            <div role="tabpanel" id="settings" class="tab-pane active">
                                <!--#MAIN_1-->
                                <div class="element-container">
                                    <div class="row">
                                        <div class="col-md-12">
                                            <div class="row">
                                                <div class="form-group">
                                                    <div class="col-md-3">
                                                        <label class="control-label" for="client_server"><?php echo _("Bitrix24 address")?></label>
                                                        <i class="fa fa-question-circle fpbx-help-icon"
                                                           data-for="client_server"></i>
                                                    </div>
                                                    <div class="col-md-2">
                                                        <select name="portal_protocol" class="form-control protocol">
                                                            <?php
                                                        $exist_client_server_port = parse_url($config['client_server'],PHP_URL_PORT);
                                                        $exist_client_server_scheme = parse_url($config['client_server'],PHP_URL_SCHEME);
                                                        ?>
                                                            <option value="https" <?php echo ($exist_client_server_scheme == "https" ? ' SELECTED' : '')?>>https</option>
                                                            <option value="http" <?php echo ($exist_client_server_scheme == "http" ? ' SELECTED' : '')?>>http</option>

                                                        </select>
                                                    </div>
                                                    <div class="col-md-5">
                                                        <input type="text" name="client_server" id="client_server"
                                                               class="form-control fields_are_required" value="<?php echo parse_url($config['client_server'],PHP_URL_HOST)?>">
                                                    </div>
                                                    <div class="col-md-2">
                                                        <input type="text" name="client_server_port" id="client_server_port"
                                                        <?php
                                                        $client_server_port = $exist_client_server_port;
                                                        ?>
                                                        class="form-control fields_are_required port" value="<?php echo $client_server_port ? $client_server_port : '443'?>">
                                                    </div>
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                    <div class="row">
                                        <div class="col-md-12">
                                            <span id="client_server-help" class="help-block fpbx-help-block"><b><?php echo _("Example")?>:<br>http(s)://yourdomain.bitrix24.ru</b></span>
                                        </div>
                                    </div>
                                </div>
                                <div class="element-container" id="div_ext_address">
                                    <div class="row">
                                        <div class="col-md-12">
                                            <div class="row">
                                                <div class="form-group">
                                                    <div class="col-md-3">
                                                        <label class="control-label" for="ext_address"><?php echo _("FreePBX address")?></label>
                                                        <i class="fa fa-question-circle fpbx-help-icon"
                                                           data-for="ext_address"></i>
                                                    </div>
                                                    <div class="col-md-2">
                                                        <select name="fpbx_protocol" class="form-control protocol">
                                                            <?php
                                                        $exist_ext_address_port = parse_url($config['ext_address'],PHP_URL_PORT);
                                                        $exist_ext_address_scheme = parse_url($config['ext_address'],PHP_URL_SCHEME);
                                                        ?>
                                                            <option value="http" <?php echo ($exist_ext_address_scheme == "http" ? ' SELECTED' : '')?>>http</option>
                                                            <option value="https" <?php echo ($exist_ext_address_scheme == "https" ? ' SELECTED' : '')?>>https</option>
                                                        </select>
                                                    </div>
                                                    <div class="col-md-5">
                                                        <input type="text" name="ext_address" id="ext_address"
                                                               class="form-control fields_are_required" value="<?php echo parse_url($config['ext_address'],PHP_URL_HOST)?>">
                                                    </div>
                                                    <div class="col-md-2">
                                                        <input type="text" name="ext_address_port" id="ext_address_port"
                                                        <?php
                                                        $ext_address_port = $exist_ext_address_port;
                                                        ?>
                                                        class="form-control fields_are_required port" value="<?php echo $ext_address_port ? $ext_address_port : '80' ?>">
                                                    </div>
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                    <div class="row">
                                        <div class="col-md-12">
                                            <span id="ext_address-help" class="help-block fpbx-help-block"><?php echo _("Please specify FreePBX address available for Bitrix24 portal for ClickToCall function to be performed and for call records to be attached.")?> <br>  <?php echo _("For ClickToCall function to work correctly you should give access or make redirect in your firewall for")?> <b>License.informunity.ru</b>.<br><b><?php echo _("Example")?>: http(s)://your_ext_ip:port</b></span>
                                        </div>
                                    </div>
                                </div>

                                
                                            
                                <?php global $amp_conf?>
                                <?php if($amp_conf['HTTPENABLED'] == 5 && $amp_conf['HTTPTLSENABLE'] == 5):?>
                                <div class="element-container" id="div_wssport">
                                    <div class="row">
                                        <div class="col-md-12">
                                            <div class="row">
                                                <div class="form-group">
                                                    <div class="col-md-3">
                                                        <label class="control-label" for="div_wssport"><?php echo _("FreePBX WSS PORT")?></label>
                                                        <i class="fa fa-question-circle fpbx-help-icon"
                                                           data-for="wssport"></i>
                                                    </div>
                                                    <div class="col-md-7"></div>
                                                    <div class="col-md-2">
                                                        <input type="text" name="wssport" id="wssport"
                                                        placeholder="<?php echo $config['wssport']?'':$amp_conf['HTTPTLSBINDPORT']?>"
                                                        class="form-control fields_are_required port" value="<?php echo $config['wssport'] ? $config['wssport'] : ''?>">
                                                    </div>
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                    <div class="row">
                                        <div class="col-md-12">
                                            <span id="wssport-help" class="help-block fpbx-help-block"><?php echo _("WSS port, that reacheble from Internet. Port must be specified for proper work of Browser Softphone Plugin")?></span>
                                        </div>
                                    </div>
                                </div>
                                <?php endif?>
                                <!--#END_MAIN_1-->

                                <!--status app b24 -->
                                <div class="element-container">
                                    <div class="row">
                                        <div class="col-md-12">
                                            <div class="row">
                                                <div class="form-group">
                                                    <div class="col-md-3">
                                                        <label class="control-label" for="status_pay_b24"><?php echo _("The app's payment status")?></label>
                                                        <i class="fa fa-question-circle fpbx-help-icon" data-for="status_pay_b24"></i>
                                                    </div>
                                                    <div class="col-md-2">
                                                        <a href="javascript:void(0);" id="status_pay_b24">
                                                            <div id="floatBarsG">
                                                                <div id="floatBarsG_1" class="floatBarsG"></div>
                                                                <div id="floatBarsG_2" class="floatBarsG"></div>
                                                                <div id="floatBarsG_3" class="floatBarsG"></div>
                                                                <div id="floatBarsG_4" class="floatBarsG"></div>
                                                                <div id="floatBarsG_5" class="floatBarsG"></div>
                                                                <div id="floatBarsG_6" class="floatBarsG"></div>
                                                                <div id="floatBarsG_7" class="floatBarsG"></div>
                                                                <div id="floatBarsG_8" class="floatBarsG"></div>
                                                            </div>
                                                        </a>
                                                    </div>
                                                </div>
                                            </div>

                                        </div>
                                    </div>
                                    <div class="row">
                                        <div class="col-md-12">
                                            <span id="status_pay_b24-help" class="help-block fpbx-help-block"><?php echo _("shows whether you have paid/demo or other app status.");?></span>
                                        </div>
                                    </div>
                                </div>
                                <!--END status app b24-->

                                <!--active before-->
                                <div class="element-container">
                                    <div class="row">
                                        <div class="col-md-12">
                                            <div class="row">
                                                <div class="form-group">
                                                    <div class="col-md-3">
                                                        <label class="control-label" for="active_before"><?php echo _("License active till")?></label>
                                                        <i class="fa fa-question-circle fpbx-help-icon" data-for="active_before"></i>
                                                    </div>
                                                    <div class="col-md-2">
                                                        <a href="javascript:void(0);" id="active_before">
                                                            <div id="floatBarsG">
                                                                <div id="floatBarsG_1" class="floatBarsG"></div>
                                                                <div id="floatBarsG_2" class="floatBarsG"></div>
                                                                <div id="floatBarsG_3" class="floatBarsG"></div>
                                                                <div id="floatBarsG_4" class="floatBarsG"></div>
                                                                <div id="floatBarsG_5" class="floatBarsG"></div>
                                                                <div id="floatBarsG_6" class="floatBarsG"></div>
                                                                <div id="floatBarsG_7" class="floatBarsG"></div>
                                                                <div id="floatBarsG_8" class="floatBarsG"></div>
                                                            </div>
                                                        </a>
                                                    </div>
                                                </div>
                                            </div>

                                        </div>
                                    </div>
                                    <div class="row">
                                        <div class="col-md-12">
                                            <span id="active_before-help" class="help-block fpbx-help-block"><?php echo _("the app is active up till this date");?></span>
                                        </div>
                                    </div>
                                </div>
                                <!--END active before-->

                                <!--extensions count from b24 -->
                                <div class="element-container">
                                    <div class="row">
                                        <div class="col-md-12">
                                            <div class="row">
                                                <div class="form-group">
                                                    <div class="col-md-3">
                                                        <label class="control-label" for="extensions_count"><?php echo _("Users with extensions")?></label>
                                                        <i class="fa fa-question-circle fpbx-help-icon" data-for="extensions_count"></i>
                                                    </div>
                                                    <div class="col-md-2">
                                                        <a href="javascript:void(0);" id="extensions_count">
                                                            <div id="floatBarsG">
                                                                <div id="floatBarsG_1" class="floatBarsG"></div>
                                                                <div id="floatBarsG_2" class="floatBarsG"></div>
                                                                <div id="floatBarsG_3" class="floatBarsG"></div>
                                                                <div id="floatBarsG_4" class="floatBarsG"></div>
                                                                <div id="floatBarsG_5" class="floatBarsG"></div>
                                                                <div id="floatBarsG_6" class="floatBarsG"></div>
                                                                <div id="floatBarsG_7" class="floatBarsG"></div>
                                                                <div id="floatBarsG_8" class="floatBarsG"></div>
                                                            </div>
                                                        </a>
                                                    </div>
                                                </div>
                                            </div>

                                        </div>
                                    </div>
                                    <div class="row">
                                        <div class="col-md-12">
                                            <span id="extensions_count-help" class="help-block fpbx-help-block"><?php echo _("the number of users who have internal numbers.");?></span>
                                        </div>
                                    </div>
                                </div>
                                <!--END extensions count from b24-->

                            </div>
                                                
                            <div role="tabpanel" id="advanced_settings" class="tab-pane">
                                <?php if($autorized):?>
                                    <!-- Check  softphone button -->
                                    <div class="element-container">
                                            <div class="row">
                                                <div class="col-md-12">
                                                    <div class="row">
                                                        <div class="form-group">
                                                            <div class="col-md-4">
                                                            </div>
                                                            <div class="col-md-3">
                                                                <label class="control-label">
                                                                    
                                                                    <input type="button" value='<?php echo _("Check WSS Softphone Compatibility")?>' data-bind="check_softphone_comp">
                                                                </label>
                                                            </div>
                                                            
                                                            <div class="col-md-9"></div>
                                                            
                                                        </div>
                                                    </div>
                                                </div>
                                            </div>
                                        </div>
                                        <!-- End check softphone button-->
                                    <?php endif;?>

                                <!--Cache ID's-->
                                <div class="element-container">
                                    <div class="row">
                                        <div class="col-md-12">
                                            <div class="row">
                                                <div class="form-group">
                                                    <div class="col-md-3">
                                                        <label class="control-label" for="clear_cache"><?php echo _("Cache")?></label>
                                                        <i class="fa fa-question-circle fpbx-help-icon" data-for="clear_cache"></i>
                                                    </div>
                                                    <div class="col-md-2">
                                                        <a href="javascript:void(0);" id="clear_cache"><?php echo _("Clear Cache")?></a>
                                                    </div>
                                                </div>
                                            </div>

                                        </div>
                                    </div>
                                    <div class="row">
                                        <div class="col-md-12">
                                            <span id="clear_cache-help" class="help-block fpbx-help-block"><?php echo _("Сlear cache in Asterisk (user ID in Bitrix24 and the internal number correspondence).");?></span>
                                        </div>
                                    </div>
                                </div>
                                <!--END Cache-->
                                <!--Requests Timeout-->
                                <div class="element-container">
                                    <div class="row">
                                        <div class="col-md-12">
                                            <div class="row">
                                                <div class="form-group">
                                                    <div class="col-md-3">
                                                        <label class="control-label" for="timeout_request"><?php echo _("Requests Timeout, sec.")?></label>
                                                        <i class="fa fa-question-circle fpbx-help-icon" data-for="timeout_request"></i>
                                                    </div>
                                                    <div class="col-md-2">
                                                        <select name="timeout_request" class="form-control protocol">
                                                            <?php for($i=3;$i <= 10; $i++):?>
                                                            <option value="<?php echo $i?>" <?php echo $config['timeout'] == $i ? 'selected' : ''?>><?php echo $i?></option>
                                                            <?php endfor;?>
                                                        </select>
                                                    </div>
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                    <div class="row">
                                        <div class="col-md-12">
                                            <span id="timeout_request-help" class="help-block fpbx-help-block"><?php echo _("Maximum waiting time. The time that the module takes to wait after sending a request to Bitrix24 or/and to a license server.");?></span>
                                        </div>
                                    </div>
                                </div>
                                <!--END Requests Timeout-->
                                <?php if($autorized == "yes"):?>
                                <!-- Records-->
                                <div class="element-container">
                                    <div class="row">
                                        <div class="col-md-12">
                                            <div class="row">
                                                <div class="form-group">
                                                    <div class="col-md-3">
                                                        <label class="control-label" for="recording"><?php echo _("Recordings")?></label>
                                                        <i class="fa fa-question-circle fpbx-help-icon" data-for="recording"></i>
                                                    </div>
                                                    <div class="col-md-9 radioset">
                                                        <input type="radio" name="recordings"
                                                               id="mp3" value="mp3" <?php echo
                                                                    ($config['recordings'] == "mp3" || empty($config['recordings'])?"CHECKED":"") ?>>
                                                        <label for="mp3"><?php echo _("Mp3");?></label>
                                                        <input type="radio" name="recordings"
                                                               id="default"
                                                               value="default" <?php echo ($config['recordings'] == "default"?"CHECKED":"") ?>>
                                                        <label for="default"><?php echo _("FreePBX Format");?></label>
                                                        <input type="radio" name="recordings"
                                                               id="not_send"
                                                               value="not_send" <?php echo ($config['recordings'] == "not_send"?"CHECKED":"") ?>>
                                                        <label for="not_send"><?php echo _("Don't Attach Records");?></label>
                                                        <input type="radio" name="recordings"
                                                               id="stereo"
                                                               value="stereo" <?php echo ($config['recordings'] == "stereo"?"CHECKED":"") ?>>
                                                        <label for="stereo"><?php echo _("Stereo");?></label>
                                                    </div>
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                    <div class="row">
                                        <div class="col-md-12">
                                            <span id="recording-help" class="help-block fpbx-help-block"><?php echo _("Allows to choose the format of the recordings sent to Bitrix24 portal.")."<br/>"._("Bitrix24 supports only mp3 and wav, records in all other formats will be attached and available for downloading.");?></span>
                                        </div>
                                    </div>
                                </div>
                                <!-- End Records -->
                                <!-- Audio links -->

                                <div class="element-container">
                                    <div class="row">
                                        <div class="col-md-12">
                                            <div class="row">
                                                <div class="form-group">
                                                    <div class="col-md-3">
                                                        <label class="control-label" for="links"><?php echo _("Links to records")?></label>
                                                        <i class="fa fa-question-circle fpbx-help-icon" data-for="links"></i>
                                                    </div>
                                                    <div class="col-md-9 radioset">
                                                        <?php
                                                        if ($config['links'] == "yes" || $amp_conf['MIXMON_FORMAT'] == 'wav'){ ?>
                                                            <input type="radio" name="links"
                                                                   id="yes" value="yes" <?php echo
                                                                        ($config['links'] == "yes" || empty($config['links'])?"CHECKED":"") ?>>
                                                            <label for="yes" id="label_yes"><?php echo _("Yes");?></label>
                                                        <?php }?>
                                                        <input type="radio" name="links"
                                                               id="no"
                                                               value="no" <?php echo ($config['links'] == "no" || $amp_conf['MIXMON_FORMAT'] != 'wav' ?"CHECKED":"") ?>>
                                                        <label for="no"><?php echo _("No");?></label>
                                                    </div>
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                    <div class="row">
                                        <div class="col-md-12">
                                            <span id="links-help" class="help-block fpbx-help-block"><?php echo _("Automatically adds the links to records.");?></span>
                                        </div>
                                    </div>
                                </div>
                                <!-- End Audio links -->
                                <!-- Region -->
                                <div class="element-container">
                                    <div class="row">
                                        <div class="col-md-12">
                                            <div class="row">
                                                <div class="form-group">
                                                    <div class="col-md-3">
                                                        <label class="control-label" for="region"><?php echo _("Identify the region for Russia")?></label>
                                                        <i class="fa fa-question-circle fpbx-help-icon" data-for="region"></i>
                                                    </div>
                                                    <div class="col-md-9 radioset">
                                                        <input id="determine_region_yes" name="determine_region"  value="yes" type="radio" <?php echo ($detRegion["det_region"] == 1) ? "checked" : ""?>>
                                                        <label for="determine_region_yes"><?php echo _("Yes")?></label>
                                                        <input id="determine_region_no" name="determine_region"  value="no" type="radio" <?php echo ($detRegion["det_region"] == 0 || empty($detRegion["det_region"])) ? "checked" : ""?>>
                                                        <label for="determine_region_no"><?php echo _("No")?></label>
                                                    </div>
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                    <div class="row">
                                        <div class="col-md-12">
                                            <span id="region-help" class="help-block fpbx-help-block"><?php echo "<strong>"._("For Russian Federation only.")."</strong><br/> "._("This option allows to identify the caller's region by his/her telephone number and then the region is displayed in the Lead (field 'Address').");?></span>
                                        </div>
                                    </div>
                                </div>
                                <!-- End Region -->
                                <?php endif;?>
                                <!-- Download log -->

                                <div class="element-container">
                                    <div class="row">
                                        <div class="col-md-12">
                                            <div class="row">
                                                <div class="form-group">
                                                    <div class="col-md-3">
                                                        <label class="control-label"><?php echo _("Download log")?></label>
                                                    </div>
                                                    <?php if(extension_loaded ('Zip')):?>

                                                    <?php if(!empty($log_files)):?>
                                                    <div class="col-md-2">
                                                        <select class="form-control protocol" name="log-files">
                                                            <?php foreach($log_files as $log_file):?>
                                                            <option value='<?php echo $log_file["FILE_NAME"]?>' data-link='<?php echo $log_file["FILE_LINK"]?>'>
                                                                <?php echo $log_file["FILE_NAME"]?>
                                                            </option>
                                                            <?php endforeach;?>
                                                        </select>
                                                    </div>
                                                    <div class="col-md-7">
                                                        <input type="button" value='<?php echo _("Download")?>' data-bind="download_log">
                                                    </div>
                                                    <?php else:?>
                                                    <div class="col-md-9"><b style="color:orange" >ERROR: <?php echo _("No log files with Verbose enabled!")?> </b><a href="config.php?display=logfiles_settings#logfiles_logfiles"><?php echo _("more...")?></a></div>
                                                    <?php endif;?>
                                                <?php else:?>
                                                <div class="col-md-9"><b style="color:red">ERROR: <?php echo _("Zip extension for PHP is not enabled")?> </b><a href="http://php.net/manual/ru/book.zip.php"><?php echo _("more...")?></a></div>
                                            <?php endif;?>


                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                </div>

                                <!-- End Download log -->

                                
                            </div>

                            

                            <!-- Inbound Destinations -->
                            <div role="tabpanel" id="inbound_destinations" class="tab-pane">

                                <div class="element-container">
                                    <div id="toolbar-all">
                                        <a class="btn btn-primary" id="inbound_dest_add">
                                            <i class="fa fa-plus"></i> <?php echo _('Add')?>
                                        </a>
                                    </div>

                                    <table id="mygrid" data-url="ajax.php?module=informunity_bitrix24&amp;command=get_did" data-cache="false" data-toolbar="#toolbar-all" data-maintain-selected="true" data-toggle="table" data-pagination="true" data-search="true" class="table table-striped">
                                        <thead>
                                        <tr>
                                            <th data-field="description"><?php echo _("Description")?></th>
                                            <th data-field="defuser"><?php echo _("Default User")?></th>
                                            <th data-field="did"><a href='config.php?display=did'><?php echo _("Inbound Destination")?></a></th>
                                            <th data-field="destination" data-formatter="DIDdestFormatter"><?php echo _("Destination")?></th>
                                            <th data-field="actions" class="col-xs-2"><?php echo _("Actions")?></th>
                                        </tr>
                                        </thead>
                                    </table>
                                </div>

                            </div>
                            <!-- end Inbound Destinations -->

                            <!-- Lines -->
                            <div role="tabpanel" id="lines_tab" class="tab-pane">

                                <div class="element-container">
                                    <div id="toolbar-all-lines">
                                        <a class="btn btn-primary" id="lines_add_button">
                                            <i class="fa fa-plus"></i> <?php echo _('Add')?>
                                        </a>
                                    </div>

                                    <table id="mygrid" data-url="ajax.php?module=informunity_bitrix24&amp;command=get_lines" data-cache="false" data-toolbar="#toolbar-all-lines" data-maintain-selected="true" data-toggle="table" data-pagination="true" data-search="true" class="table table-striped">
                                        <thead>
                                        <tr>
                                            <th data-field="lines-did"><?php echo _("DID")?></th>
                                            <th data-field="number"><?php echo _("Number")?></th>
                                            <th data-field="actions" class="col-xs-2"><?php echo _("Actions")?></th>
                                        </tr>
                                        </thead>
                                    </table>
                                </div>

                            </div>
                            <!-- end Lines -->

                            <!-- Outbound Routes -->
                            <div role="tabpanel" id="outbound_routes" class="tab-pane">

                                <div class="element-container">
                                    <div id="toolbar-all-routes">

                                    </div>

                                    <table id="mygrid" data-url="ajax.php?module=informunity_bitrix24&amp;command=outbound_routes_get" data-cache="false" data-toolbar="#toolbar-all-routes" data-maintain-selected="true" data-toggle="table" data-pagination="true" data-search="true" class="table table-striped">
                                        <thead>
                                        <tr>
                                            <th data-field="name"><?php echo _("Description")?></th>
                                            <th data-field="status"><?php echo _("Status")?></th>
                                            <th data-field="actions" class="col-xs-2"><?php echo _("Actions")?></th>
                                        </tr>
                                        </thead>
                                    </table>
                                </div>

                            </div>
                            <!-- end Outbound Routes -->


                            <!-- b24 handlers callback -->
                            <div role="tabpanel" id="callback_handlers" class="tab-pane">
                                <?php #MAIN_2 ?>
                                <div class="element-container">
                                    <div class="row">
                                        <div class="col-md-12">
                                            <div class="row">
                                                <div class="form-group">
                                                    <div class="col-md-3">
                                                        <label class="control-label" for="click_call_reg"><?php echo _("Click to Call")?></label>
                                                        <i class="fa fa-question-circle fpbx-help-icon" data-for="click_call_reg"></i>
                                                    </div>
                                                    <div class="col-md-2" data-placement="isRegisterCall">
                                                        <div id="floatBarsG">
                                                            <div id="floatBarsG_1" class="floatBarsG"></div>
                                                            <div id="floatBarsG_2" class="floatBarsG"></div>
                                                            <div id="floatBarsG_3" class="floatBarsG"></div>
                                                            <div id="floatBarsG_4" class="floatBarsG"></div>
                                                            <div id="floatBarsG_5" class="floatBarsG"></div>
                                                            <div id="floatBarsG_6" class="floatBarsG"></div>
                                                            <div id="floatBarsG_7" class="floatBarsG"></div>
                                                            <div id="floatBarsG_8" class="floatBarsG"></div>
                                                        </div>
                                                    </div>
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                    <div class="row">
                                        <div class="col-md-12">
                                            <span id="click_call_reg-help" class="help-block fpbx-help-block"><?php echo _("Outbound Bitrix24 calls handler.");?></span>
                                        </div>
                                    </div>
                                </div>
                                <!-- Auto Answer -->
                                <div class="element-container">
                                    <div class="row">
                                        <div class="col-md-12">
                                            <div class="row">
                                                <div class="form-group">
                                                    <div class="col-md-3">
                                                        <label class="control-label" for="ctc_autoanswer"><?php echo _("Auto Answer Click To Call")?></label>
                                                        <i class="fa fa-question-circle fpbx-help-icon" data-for="ctc_autoanswer"></i>
                                                    </div>
                                                    <div class="col-md-9 radioset">
                                                        <input id="ctc_autoanswer_yes" name="ctc_autoanswer"  value="1" type="radio" <?php echo ($config["ctc_autoanswer"] == 1) ? "checked" : ""?>>
                                                        <label for="ctc_autoanswer_yes"><?php echo _("Yes")?></label>
                                                        <input id="ctc_autoanswer_no" name="ctc_autoanswer"  value="0" type="radio" <?php echo ($config["ctc_autoanswer"] == 0 || empty($config["ctc_autoanswer"])) ? "checked" : ""?>>
                                                        <label for="ctc_autoanswer_no"><?php echo _("No")?></label>
                                                    </div>
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                    <div class="row">
                                        <div class="col-md-12">
                                            <span id="ctc_autoanswer-help" class="help-block fpbx-help-block"><?php echo _("if Yes it will pick up the phone automatically.");?></span>
                                        </div>
                                    </div>
                                </div>
                                <!-- End Auto Answer -->

                                <!--Call Back-->
                                <div class="element-container">
                                    <div class="row">
                                        <div class="col-md-12">
                                            <div class="row">
                                                <div class="form-group">
                                                    <div class="col-md-3">
                                                        <label class="control-label" for="click_back_reg"><?php echo _("Call Back")?></label>
                                                        <i class="fa fa-question-circle fpbx-help-icon" data-for="click_back_reg"></i>
                                                    </div>
                                                    <div class="col-md-2" data-placement="isRegisterCallback">
                                                        <div id="floatBarsG">
                                                            <div id="floatBarsG_1" class="floatBarsG"></div>
                                                            <div id="floatBarsG_2" class="floatBarsG"></div>
                                                            <div id="floatBarsG_3" class="floatBarsG"></div>
                                                            <div id="floatBarsG_4" class="floatBarsG"></div>
                                                            <div id="floatBarsG_5" class="floatBarsG"></div>
                                                            <div id="floatBarsG_6" class="floatBarsG"></div>
                                                            <div id="floatBarsG_7" class="floatBarsG"></div>
                                                            <div id="floatBarsG_8" class="floatBarsG"></div>
                                                        </div>

                                                    </div>
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                    <div class="row">
                                        <div class="col-md-12">
                                            <span id="click_back_reg-help" class="help-block fpbx-help-block"><?php echo _("Widget site callback handler.");?></span>
                                        </div>
                                    </div>
                                </div>
                                <!--END Call Back-->

                                <?php #END_MAIN_2 ?>
                                <!--Call Back DEST-->
                                    <div class="element-container">
                                        <div class="row">
                                            <div class="col-md-12">
                                                <div class="row">
                                                    <div class="form-group">
                                                        <div class="col-md-3">
                                                            <label class="control-label" for="click_back_reg_dest"><?php echo _("Call Back Destination")?></label>
                                                            <i class="fa fa-question-circle fpbx-help-icon" data-for="click_back_reg_dest"></i>
                                                        </div>
                                                        <div class="col-md-2">
                                                            <div class="dest_ajax_handlers"><?php echo drawselects((isset($config['call_back_dest']) ? $config['call_back_dest'] : ""),0, array("core" => array("extensions","trunks"), "ivr", "queues", "setcid","ringgroups","announcement","timeconditions"), true, '', false, false, false, false, 'dest_settings_b24_handlers')?></div>
                                                        </div>
                                                    </div>
                                                </div>
                                            </div>
                                        </div>
                                        <div class="row">
                                            <div class="col-md-12">
                                                <span id="click_back_reg_dest-help" class="help-block fpbx-help-block"><?php echo _("Destination for site widget callback.");?></span>
                                            </div>
                                        </div>
                                    </div>
                            </div>
                            <!-- END Call Back DEST -->

                            <!-- Tasks -->
                            <div role="tabpanel" id="tasks" class="tab-pane">

                                <div class="element-container">
                                    <div id="toolbar-all-task">
                                        <a class="btn btn-primary" id="task_add_button">
                                            <i class="fa fa-plus"></i> <?php echo _('Add')?>
                                        </a>
                                    </div>

                                    <table id="mygrid" data-url="ajax.php?module=informunity_bitrix24&amp;command=get_tasks" data-cache="false" data-toolbar="#toolbar-all-task" data-maintain-selected="true" data-toggle="table" data-pagination="true" data-search="true" class="table table-striped">
                                        <thead>
                                        <tr>
                                            <th data-field="id"><?php echo _("ID")?></th>
                                            <th data-field="task_name"><?php echo _("Task name")?></th>
                                            <th data-field="observers"><?php echo _("Observers")?></th>
                                            <th data-field="deadline"><?php echo _("Deadline")?></th>
                                            <th data-field="actions" class="col-xs-2"><?php echo _("Actions")?></th>
                                        </tr>
                                        </thead>
                                    </table>
                                </div>

                            </div>
                            <!-- end Tasks -->

                            <!-- Exceptions -->
                            <div role="tabpanel" id="exceptions" class="tab-pane">
                                <div class="element-container">
                                    <div id="toolbar-all-exception">
                                        <a class="btn btn-primary" id="exception_add_button">
                                            <i class="fa fa-plus"></i> <?php echo _('Add')?>
                                        </a>
                                    </div>
                                    <table id="mygrid" data-url="ajax.php?module=informunity_bitrix24&amp;command=get_exceptions" data-cache="false" data-toolbar="#toolbar-all-exception" data-maintain-selected="true" data-toggle="table" data-pagination="true" data-search="true" class="table table-striped">
                                        <thead>
                                        <tr>
                                            <th data-field="id"><?php echo _("ID")?></th>
                                            <th data-field="description"><?php echo _("Description")?></th>
                                            <th data-field="actions" class="col-xs-2"><?php echo _("Actions")?></th>
                                        </tr>
                                        </thead>
                                    </table>
                                </div>
                            </div>
                            <!-- end Exceptions -->
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </div>
</div>

<div id="templates-informunity-b24">
    <div role="tabpanel" id="advanced_ver" class="tab-pane">
        <div class="element-container">
            <div class="row">
                <div class="col-md-12">
                    <div class="row">
                        <div class="form-group">
                            <div class="col-md-3">
                                <label class="control-label" for="access_code"><?php echo _("Application ID")?></label>
                            </div>
                            <div class="col-md-9">
                                <input type="text" name="access_code" id="access_code" class="form-control fields_are_required" value="">
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>

<div id="templates-informunity-b24-nav">
    <li role="presentation" data-name="advanced_ver">
        <a href="#advanced_ver" aria-controls="advanced_ver" role="tab" data-toggle="tab"  style="color:red;">! <?php echo _("Enter Application ID")?> ! </a>
    </li>
</div>

<!-- шаблоны диалогов -->
<div id="templates-dialogs-module">

    <!-- диалог обновления, сюда клонируется диалог создания outbound routes-->
    <div id="update_outbound" class="dialog-form-module" title="<?php echo _("Outbound Route")?>: <?php echo _("Update")?>">
        <div class="container-fluid">
            <div class="display full-border">
                <div class="row">
                    <div class="col-sm-12">
                        <div class="fpbx-container">
                            <div class="display full-border">

                                <!-- hide id when update form -->
                                <span class="update_did_form" style="display: none;" data-did-id=""></span>
                                <!--Description-->
                                <div class="element-container">
                                    <div class="row">
                                        <div class="col-md-12">
                                            <div class="row">
                                                <div class="form-group">
                                                    <div class="col-md-4">
                                                        <label class="control-label" for="description"><?php echo _("Description")?></label>
                                                    </div>
                                                    <div class="col-md-8">
                                                        <input class="form-control" id="description" name="description" value="" type="text" disabled>
                                                    </div>
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                                <!--END Description-->
                                <!--Status-->
                                <div class="element-container">
                                    <div class="row">
                                        <div class="col-md-12">
                                            <div class="row">
                                                <div class="form-group">
                                                    <div class="col-md-4">
                                                        <label class="control-label" for="status_mode"><?php echo _("Status")?></label>
                                                        <i class="fa fa-question-circle fpbx-help-icon" data-for="status_mode"></i>
                                                    </div>
                                                    <div class="col-md-8 radioset">
                                                        <input id="record_enabled_update" name="status_mode" value="yes" type="radio">
                                                        <label for="record_enabled_update"><?php echo _("Enabled")?></label>
                                                        <input id="record_disabled_update" name="status_mode" value="no" type="radio">
                                                        <label for="record_disabled_update"><?php echo _("Disabled")?></label>

                                                        <input id="record_assassement_update" name="status_mode" value="voting" type="radio">
                                                        <label for="record_assassement_update"><?php echo _("Assessement")?></label>
                                                    </div>
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                    <div class="row">
                                        <div class="col-md-12">
                                            <span id="status_mode-help" class="help-block fpbx-help-block"><?php echo _("Enable/ Disable in a route/ Enable with the following assessment.");?></span>
                                        </div>
                                    </div>
                                </div>
                                <!--END Status-->
                                <!--Greatings Message-->
                                <div class="element-container show_div_greet" style="display: none;">
                                    <div class="row">
                                        <div class="col-md-12">
                                            <div class="row">
                                                <div class="form-group">
                                                    <div class="col-md-4">
                                                        <label class="control-label" for="out_greatings"><?php echo _("Initial message") ?></label>
                                                        <i class="fa fa-question-circle fpbx-help-icon" data-for="out_greatings"></i>
                                                    </div>
                                                    <div class="col-md-8">
                                                        <select class="form-control" id="greatings" name="greatings">
                                                            <?php echo $greatings?>
                                                        </select>
                                                    </div>
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                    <div class="row">
                                        <div class="col-md-12">
                                            <span id="out_greatings-help" class="help-block fpbx-help-block"><?php echo _("voice greeting before assessment.");?></span>
                                        </div>
                                    </div>
                                </div>
                                <!--END-Greatings Message-->
                                <!--Thanks Message-->
                                <div class="element-container show_div_bye" style="display: none;">
                                    <div class="row">
                                        <div class="col-md-12">
                                            <div class="row">
                                                <div class="form-group">
                                                    <div class="col-md-4">
                                                        <label class="control-label" for="out_bye"><?php echo _("Final message") ?></label>
                                                        <i class="fa fa-question-circle fpbx-help-icon" data-for="out_bye"></i>
                                                    </div>
                                                    <div class="col-md-8">
                                                        <select class="form-control" id="bye" name="bye">
                                                            <?php echo $bye?>
                                                        </select>
                                                    </div>
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                    <div class="row">
                                        <div class="col-md-12">
                                            <span id="out_bye-help" class="help-block fpbx-help-block"><?php echo _("voice message after assessment.");?></span>
                                        </div>
                                    </div>
                                </div>
                                <!--END-Thanks Message-->
                                <!--Exception-->
                                <div class="element-container">
                                    <div class="row">
                                        <div class="col-md-12">
                                            <div class="row">
                                                <div class="form-group">
                                                    <div class="col-md-4">
                                                        <label class="control-label" for="out_exceptions"><?php echo _("Exceptions") ?></label>
                                                        <i class="fa fa-question-circle fpbx-help-icon" data-for="out_exceptions"></i>
                                                    </div>
                                                    <div class="col-md-8" data-placement="out_exceptions">
                                                        <?php if(is_array($exceptions) && !empty($exceptions)):?>

                                                        <select class="form-control" id="exclusions" name="exclusions">
                                                            <option value=""><?php echo _("Select") ?></option>
                                                            <?php foreach($exceptions as $exception):?>
                                                            <option value="<?php echo $exception['id']?>"><?php echo $exception['description']?></option>
                                                            <?php endforeach?>
                                                        </select>
                                                        <?php endif?>
                                                    </div>
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                    <div class="row">
                                        <div class="col-md-12">
                                            <span id="out_exceptions-help" class="help-block fpbx-help-block"><?php echo _("list of users that do not get assigned with calls and do not receive pop-up call cards (to configure the list, please see Exceptions tab in the upper bar).");?></span>
                                        </div>
                                    </div>
                                </div>
                                <!--END-Exception-->
                                <!--Source-->
                                <div class="element-container">
                                    <div class="row">
                                        <div class="col-md-12">
                                            <div class="row">
                                                <div class="form-group">
                                                    <div class="col-md-4">
                                                        <label class="control-label" for="out_source_route"><?php echo _("Source") ?></label>
                                                        <i class="fa fa-question-circle fpbx-help-icon" data-for="out_source_route"></i>
                                                    </div>
                                                    <div class="col-md-8" data-placement="source-options">
                                                        <div id="floatBarsG">
                                                            <div id="floatBarsG_1" class="floatBarsG"></div>
                                                            <div id="floatBarsG_2" class="floatBarsG"></div>
                                                            <div id="floatBarsG_3" class="floatBarsG"></div>
                                                            <div id="floatBarsG_4" class="floatBarsG"></div>
                                                            <div id="floatBarsG_5" class="floatBarsG"></div>
                                                            <div id="floatBarsG_6" class="floatBarsG"></div>
                                                            <div id="floatBarsG_7" class="floatBarsG"></div>
                                                            <div id="floatBarsG_8" class="floatBarsG"></div>
                                                        </div>
                                                        <select class="form-control" id="source_route" name="source_route">
                                                            
                                                        </select>
                                                    </div>
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                    <div class="row">
                                        <div class="col-md-12">
                                            <span id="out_source_route-help" class="help-block fpbx-help-block"><?php echo _("call source is taken from Bitrix24. It does not affect the call routing.");?></span>
                                        </div>
                                    </div>
                                </div>
                                <!--END-Source-->
                                <!--Create Lead-->
                                <div class="element-container">
                                    <div class="row ">
                                        <div class="col-md-12">
                                            <div class="row">
                                                <div class="form-group">
                                                    <div class="col-md-4">
                                                        <label class="control-label" for="out_create_lead"><?php echo _("Create Lead")?></label>
                                                        <i class="fa fa-question-circle fpbx-help-icon" data-for="out_create_lead"></i>
                                                    </div>
                                                    <div class="col-md-8 radioset">
                                                        <input id="create_lead_yes" name="create_lead"  value="yes" type="radio">
                                                        <label for="create_lead_yes"><?php echo _("Yes")?></label>
                                                        <input id="create_lead_no" name="create_lead"  value="no" type="radio">
                                                        <label for="create_lead_no"><?php echo _("No")?></label>
                                                    </div>

                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                    <div class="row">
                                        <div class="col-md-12">
                                            <span id="out_create_lead-help" class="help-block fpbx-help-block"><?php echo _("create a new lead and deal.");?></span>
                                        </div>
                                    </div>
                                </div>
                                <!--END Create Lead-->
                                <!--Show Card-->
                                <div class="element-container" >
                                    <div class="row">
                                        <div class="col-md-12">
                                            <div class="row">
                                                <div class="form-group">
                                                    <div class="col-md-4">
                                                        <label class="control-label" for="out_show_card"><?php echo _("Show Card")?></label>
                                                        <i class="fa fa-question-circle fpbx-help-icon" data-for="out_show_card"></i>
                                                    </div>
                                                    
                                                        <div class="col-md-8 radioset">
                                                            <input id="show_card_route_yes" name="show_card_route"  value="yes" type="radio"">
                                                            <label for="show_card_route_yes"><?php echo _("Yes")?></label>
                                                            <input id="show_card_route_no" name="show_card_route"  value="no" type="radio">
                                                            <label for="show_card_route_no"><?php echo _("No")?></label>
                                                        </div>
                                                    
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                    <div class="row">
                                        <div class="col-md-12">
                                            <span id="out_show_card-help" class="help-block fpbx-help-block"><?php echo _("display call profile in Bitrix24.");?></span>
                                        </div>
                                    </div>
                                </div>
                                <!--END Show Card-->
                                <!--Advanced Settings-->
                                <a class="showNumberModify"><?php echo _("Advanced Settings")?></a>
                                <div class="element-container showNumberModifyInput">
                                    <div class="row"> 
                                        <div class="col-md-12">
                                            <div class="row" >
                                                <div class="form-group">
                                                    <div class="col-md-4">
                                                        <label class="control-label" for="out_number_modify"><?php echo _("Number Modification for Bitrix24")?></label>
                                                        <i class="fa fa-question-circle fpbx-help-icon" data-for="out_number_modify"></i>
                                                    </div>
                                                        <div class="col-md-8">
                                                            <input class="form-control" placeholder="${EXTEN}" id="modify_number_first" name="modify_number_first"  value="" type="text">
                                                        </div>
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                    <div class="row">
                                        <div class="col-md-12">
                                            <span id="out_number_modify-help" class="help-block fpbx-help-block"><?php echo _("modifications of the number that is transferred to Bitrix24. It does not affect the call routing. Modifications are made in the same way as with Asterisk variables.");?></span>
                                        </div>
                                    </div>
                                </div>
                                <!--END Advanced Settings-->
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>

    <!-- диалог удаления с подтверждением outbound routes-->
    <div id="delete_outbound" title="Outbound Route ID">
        <p><span class="ui-icon ui-icon-alert" style="float:left; margin:12px 12px 20px 0;"></span><?php echo _("These items will be permanently deleted and cannot be recovered in the future. Do you want to proceed?")?></p>
    </div>

    <!-- диалог обновления, сюда клонируется диалог создания-->
    <div id="update_inbound" class="dialog-form-module" title="<?php echo _("Inbound Destination")?>: <?php echo _("Update")?>">
    <div class="container-fluid">
        <div class="display full-border">
            <div class="row">
                <div class="col-sm-12">
                    <div class="fpbx-container">
                        <div class="display full-border">

                            <!-- hide id when update form -->
                            <span class="update_did_form" style="display: none;" data-did-id=""></span>

                            <!--Description-->
                            <div class="element-container">
                                <div class="row">
                                    <div class="col-md-12">
                                        <div class="row">
                                            <div class="form-group">
                                                <div class="col-md-4">
                                                    <label class="control-label" for="description"><?php echo _("Description")?></label>
                                                </div>
                                                <div class="col-md-8">
                                                    <input class="form-control" id="description" name="description" value="" type="text">
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                </div>

                            </div>
                            <!--END Description-->

                            <!--User Portal-->
                            <div class="element-container">
                                <div class="row">
                                    <div class="col-md-12">
                                        <div class="row">
                                            <div class="form-group">
                                                <div class="col-md-4">
                                                    <label class="control-label" for="users-from-portal"><?php echo _("Default User")?></label>
                                                    <i class="fa fa-question-circle fpbx-help-icon" data-for="users-from-portal"></i>
                                                </div>
                                                <div class="col-md-8" data-placement="users-from-portal">
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                                <div class="row">
                                    <div class="col-md-12">
                                        <span id="users-from-portal-help" class="help-block fpbx-help-block"><?php echo _("manager, to whom the event is tied to, if the call was not answered and an incoming call was designated to none of other managers.");?></span>
                                    </div>
                                </div>
                            </div>
                            <!--END User Portal-->
                            <!--Exception-->
                            <div class="element-container">
                                <div class="row">
                                    <div class="col-md-12">
                                        <div class="row">
                                            <div class="form-group">
                                                <div class="col-md-4">
                                                    <label class="control-label" for="exclusions-options"><?php echo _("Exceptions") ?></label>
                                                    <i class="fa fa-question-circle fpbx-help-icon" data-for="exclusions-options"></i>
                                                </div>
                                                <div class="col-md-8" data-placement="exclusions-options">

                                                    <select class="form-control" id="exclusions" name="exclusions">
                                                        <option value=""><?php echo _("Select") ?></option>
                                                        <?php foreach($exceptions as $exception):?>
                                                        <option value="<?php echo $exception['id']?>"><?php echo $exception['description']?></option>
                                                        <?php endforeach?>
                                                    </select>
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                                <div class="row">
                                    <div class="col-md-12">
                                        <span id="exclusions-options-help" class="help-block fpbx-help-block"><?php echo _("list of users that do not get assigned with calls and do not receive pop-up call cards (to configure the list, please see Exceptions tab in the upper bar).");?></span>
                                    </div>
                                </div>
                            </div>
                            <!--END-Exception-->
                            <!--Show Caller Name-->
                            <div class="element-container">
                                <div class="row">
                                    <div class="col-md-12">
                                        <div class="row">
                                            <div class="form-group">
                                                <div class="col-md-4">
                                                    <label class="control-label" for="show_caller_name-u"><?php echo _("Show Caller Name")?></label>
                                                    <i class="fa fa-question-circle fpbx-help-icon" data-for="show_caller_name-u"></i>
                                                </div>
                                                <div class="col-md-8 radioset">
                                                    <input id="show_caller_name_yes_update" name="show_caller_name"  value="yes" type="radio">
                                                    <label for="show_caller_name_yes_update"><?php echo _("Yes")?></label>
                                                    <input id="show_caller_name_no_update" name="show_caller_name"  value="no" type="radio">
                                                    <label for="show_caller_name_no_update"><?php echo _("No")?></label>
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                                <div class="row">
                                    <div class="col-md-12">
                                        <span id="show_caller_name-u-help" class="help-block fpbx-help-block"><?php echo _("caller name will be displayed in the SIP phone/ softphone.");?></span>
                                    </div>
                                </div>
                            </div>
                            <!--END-Show Caller Name-->
                            <!-- Add to chat -->
                            <div class="element-container">
                                <div class="row">
                                    <div class="col-md-12">
                                        <div class="row">
                                            <div class="form-group">
                                                <div class="col-md-4">
                                                    <label class="control-label" for="add_to_chat_u"><?php echo _("Add to chat")?></label>
                                                    <i class="fa fa-question-circle fpbx-help-icon" data-for="add_to_chat_u"></i>
                                                </div>
                                                <div class="col-md-8 radioset">
                                                    <input id="add_to_chat_no_update" name="add_to_chat"  value="No" type="radio">
                                                    <label for="add_to_chat_no_update"><?php echo _("No")?></label>
                                                    <input id="add_to_chat_answer_update" name="add_to_chat"  value="NoAnswered" type="radio">
                                                    <label for="add_to_chat_answer_update"><?php echo _("Unanswered")?></label>
                                                    <input id="add_to_chat_all_update" name="add_to_chat"  value="All" type="radio">
                                                    <label for="add_to_chat_all_update"><?php echo _("All")?></label>

                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                                <div class="row">
                                    <div class="col-md-12">
                                        <span id="add_to_chat_u-help" class="help-block fpbx-help-block"><?php echo _("show calls in the chat list. No Answered — only unanswered calls, All — all calls.");?></span>
                                    </div>
                                </div>
                            </div>
                            <!-- End Add to chat -->
                            <!-- Assign Missed Calls to-->
                            <div class="element-container">
                                <div class="row">
                                    <div class="col-md-12">
                                        <div class="row">
                                            <div class="form-group">
                                                <div class="col-md-4">
                                                    <label class="control-label" for="assign_u"><?php echo _("Assign Missed Calls to")?></label>
                                                    <i class="fa fa-question-circle fpbx-help-icon" data-for="assign_u"></i>
                                                </div>
                                                <div class="col-md-8 radioset">
                                                    <input id="assign_default_update" name="assign"  value="default" type="radio" checked="checked">
                                                    <label for="assign_default_update"><?php echo _("Default User")?></label>
                                                    <input id="assign_manager_update" name="assign"  value="manager" type="radio">
                                                    <label for="assign_manager_update"><?php echo _("Assigned Manager")?></label>
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                                <div class="row">
                                    <div class="col-md-12">
                                        <span id="assign_u-help" class="help-block fpbx-help-block"><?php echo _("choose destination in case of a missed call — Default User or Assigned Manager.");?></span>
                                    </div>
                                </div>
                            </div>
                            <!--END Assign Missed Calls to-->
                            <!-- Tasks -->
                            <div class="element-container">
                                <div class="row">
                                    <div class="col-md-12">
                                        <div class="row">
                                            <div class="form-group">
                                                <div class="col-md-4">
                                                    <label class="control-label" for="did_tasks_u"><?php echo _("Create Task On Missed Call")?></label>
                                                    <i class="fa fa-question-circle fpbx-help-icon" data-for="did_tasks_u"></i>
                                                </div>
                                                <div class="col-md-8">
                                                    <?php if(!empty($tasks) && is_array($tasks)):?>
                                                    <select name="did_tasks" class="form-control did_tasks" id="did_tasks">
                                                        <option value="0"><?php echo _("Disabled")?></option>
                                                        <?php foreach($tasks as $task):?>
                                                        <option value="<?php echo $task['id']?>">
                                                            <?php echo $task['name']?>
                                                        </option>
                                                        <?php endforeach?>
                                                    </select>
                                                    <?php else:?>
                                                    <?php echo _("There are no available task templates.")?>
                                                    <?php endif;?>
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                                <div class="row">
                                    <div class="col-md-12">
                                        <span id="did_tasks_u-help" class="help-block fpbx-help-block"><?php echo _("this option allows to choose the necessary task form for missed calls.");?></span>
                                    </div>
                                </div>
                            </div>
                            <!-- END Tasks -->
                            <!-- Show Card -->
                            <div class="element-container">
                                <div class="row">
                                    <div class="col-md-12">
                                        <div class="row">
                                            <div class="form-group">
                                                <div class="col-md-4">
                                                    <label class="control-label" for="show_card_u"><?php echo _("Show Card")?></label>
                                                    <i class="fa fa-question-circle fpbx-help-icon" data-for="show_card_u"></i>
                                                </div>
                                                <div class="col-md-8 radioset">
                                                    <input id="show_card_yes_update" name="show_card"  value="yes" type="radio">
                                                    <label for="show_card_yes_update"><?php echo _("Yes")?></label>
                                                    <input id="show_card_no_update" name="show_card"  value="no" type="radio">
                                                    <label for="show_card_no_update"><?php echo _("No")?></label>
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                                <div class="row">
                                    <div class="col-md-12">
                                        <span id="show_card_u-help" class="help-block fpbx-help-block"><?php echo _("display call profile in Bitrix24.");?></span>
                                    </div>
                                </div>
                            </div>
                            <!--End Show Card -->
                            <!-- Create Lead -->
                            <div class="element-container">
                                <div class="row">
                                    <div class="col-md-12">
                                        <div class="row">
                                            <div class="form-group">
                                                <div class="col-md-4">
                                                    <label class="control-label" for="create_lead_u"><?php echo _("Create Lead")?></label>
                                                    <i class="fa fa-question-circle fpbx-help-icon" data-for="create_lead_u"></i>
                                                </div>

                                                <div class="col-md-8 radioset">
                                                    <input id="create_lead_yes_update" name="create_lead"  value="yes" type="radio">
                                                    <label for="create_lead_yes_update"><?php echo _("Yes")?></label>
                                                    <input id="create_lead_no_update" name="create_lead"  value="no" type="radio">
                                                    <label for="create_lead_no_update"><?php echo _("No")?></label>
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                                <div class="row">
                                    <div class="col-md-12">
                                        <span id="create_lead_u-help" class="help-block fpbx-help-block"><?php echo _("create a new lead and deal.");?></span>
                                    </div>
                                </div>
                            </div>
                            <!--End Create Lead -->
                            <!--Source-->
                            <div class="element-container">
                                <div class="row">
                                    <div class="col-md-12">
                                        <div class="row">
                                            <div class="form-group">
                                                <div class="col-md-4">
                                                    <label class="control-label" for="source-options_u"><?php echo _("Source") ?></label>
                                                    <i class="fa fa-question-circle fpbx-help-icon" data-for="source-options_u"></i>
                                                </div>
                                                <div class="col-md-8" data-placement="source-options">
                                                    <div id="floatBarsG">
                                                        <div id="floatBarsG_1" class="floatBarsG"></div>
                                                        <div id="floatBarsG_2" class="floatBarsG"></div>
                                                        <div id="floatBarsG_3" class="floatBarsG"></div>
                                                        <div id="floatBarsG_4" class="floatBarsG"></div>
                                                        <div id="floatBarsG_5" class="floatBarsG"></div>
                                                        <div id="floatBarsG_6" class="floatBarsG"></div>
                                                        <div id="floatBarsG_7" class="floatBarsG"></div>
                                                        <div id="floatBarsG_8" class="floatBarsG"></div>
                                                    </div>
                                                    <select class="form-control" id="source" name="source">

                                                    </select>
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                                <div class="row">
                                    <div class="col-md-12">
                                        <span id="source-options_u-help" class="help-block fpbx-help-block"><?php echo _("call source is taken from Bitrix24. It does not affect the call routing.");?></span>
                                    </div>
                                </div>
                            </div>
                            <!--END-Source-->
                            <!--Manager-->
                            <div class="element-container">
                                <div class="row">
                                    <div class="col-md-12">
                                        <div class="row">
                                            <div class="col-md-12">
                                                <div class="row">
                                                    <div class="form-group">
                                                        <div class="col-md-4">
                                                            <label class="control-label" for="consider_manager_update"><?php echo _("Destination for registered callers")?></label>
                                                            <i class="fa fa-question-circle fpbx-help-icon" data-for="consider_manager_update"></i>
                                                        </div>
                                                        <div class="col-md-3">
                                                            <div class="manager_ajax"><?php echo drawselects((isset($item['dest']) ? $item['dest'] : "manager_in_charge,exit"),1, array("informunity_bitrix24"=>array("manager_in_charge"),"core" => array("extensions"), "ivr", "queues","ringgroups","timeconditions"), true, '', false, false, true, false, 'consider_manager')?></div>
                                                        </div>
                                                        <div hidden class="element-container show_div_ringtimer">
                                                            <div class="col-md-3">
                                                                <label class="control-label" for="assigned_manager_ring_timer"><?php echo _("Ring Time")?></label>
                                                            </div>
                                                            <div class="col-md-3">
                                                                <input class="form-control" id="assigned_manager_ring_timer" name="assigned_manager_ring_timer" value="" type="text">
                                                            </div>
                                                        </div>
                                                    </div>
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                                <div class="row">
                                    <div class="col-md-12">
                                        <span id="consider_manager_update-help" class="help-block fpbx-help-block"><?php echo _("if “Extension” is selected the call will be redirected to manager responsible for lead or contact with the current call number, if “Extension&Mobile” is selected, manager will receive the call to mobile phone if he doesn’t take the internal call.<br>When choosing a queue, a ring group or an IVR, the call follows Failover Destination of the listed modules.");?></span>
                                    </div>
                                </div>
                            </div>
                            <!--END Manager-->
                            <!--Assassement-->
                            <div class="element-container">
                                <div class="row">
                                    <div class="col-md-12">
                                        <div class="row">
                                            <div class="form-group">
                                                <div class="col-md-4">
                                                    <label class="control-label" for="callrecording_mode_u"><?php echo _("Assassement")?></label>
                                                    <i class="fa fa-question-circle fpbx-help-icon" data-for="callrecording_mode_u"></i>
                                                </div>
                                                <div class="col-md-8 radioset">
                                                    <input id="record_yes_update" name="callrecording_mode" value="yes" type="radio">
                                                    <label for="record_yes_update"><?php echo _("Yes")?></label>
                                                    <input id="record_no_update" name="callrecording_mode" value="no" type="radio" checked="checked">
                                                    <label for="record_no_update"><?php echo _("No")?></label>
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                                <div class="row">
                                    <div class="col-md-12">
                                        <span id="callrecording_mode_u-help" class="help-block fpbx-help-block"><?php echo _("upon the call client will be offered to assess quality of service by pressing button (0–5) at the phone.");?></span>
                                    </div>
                                </div>
                            </div>
                            <!--END Assassement-->
                            <!--Initial message-->
                            <div class="element-container show_div_greet" style="display: none;">
                                <div class="row">
                                    <div class="col-md-12">
                                        <div class="row">
                                            <div class="form-group">
                                                <div class="col-md-4">
                                                    <label class="control-label" for="greatings_u"><?php echo _("Initial message") ?></label>
                                                    <i class="fa fa-question-circle fpbx-help-icon" data-for="greatings_u"></i>
                                                </div>
                                                <div class="col-md-8">
                                                    <select class="form-control" id="greatings" name="greatings">
                                                        <?php echo $greatings?>
                                                    </select>
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                                <div class="row">
                                    <div class="col-md-12">
                                        <span id="greatings_u-help" class="help-block fpbx-help-block"><?php echo _("voice greeting before assessment.");?></span>
                                    </div>
                                </div>
                            </div>
                            <!--END Initial message-->
                            <!--Final message-->
                            <div class="element-container show_div_bye" style="display: none;">
                                <div class="row">
                                    <div class="col-md-12">
                                        <div class="row">
                                            <div class="form-group">
                                                <div class="col-md-4">
                                                    <label class="control-label" for="bye_u"><?php echo _("Final message") ?></label>
                                                    <i class="fa fa-question-circle fpbx-help-icon" data-for="bye_u"></i>
                                                </div>
                                                <div class="col-md-8">
                                                    <select class="form-control" id="bye" name="bye">
                                                        <?php echo $bye?>
                                                    </select>
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                                <div class="row">
                                    <div class="col-md-12">
                                        <span id="bye_u-help" class="help-block fpbx-help-block"><?php echo _("voice message after assessment.");?></span>
                                    </div>
                                </div>
                            </div>
                            <!--END Final message-->
                            <!--Destination-->
                            <div class="element-container">
                                <div class="row">
                                    <div class="col-md-12">
                                        <div class="row">
                                            <div class="form-group">
                                                <div class="col-md-4">
                                                    <label class="control-label" for="dest_ajax_u"><?php echo _("Destination")?></label>
                                                    <i class="fa fa-question-circle fpbx-help-icon" data-for="dest_ajax_u"></i>
                                                </div>
                                                <div class="col-md-8">
                                                    <div class="dest_ajax"></div>
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                                <div class="row">
                                    <div class="col-md-12">
                                        <span id="dest_ajax_u-help" class="help-block fpbx-help-block"><?php echo _("call destination.");?></span>
                                    </div>
                                </div>
                            </div>
                            <!--END Destination-->

                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
    </div>

    <!-- диалог удаления с подтверждением-->
    <div id="delete_inbound" title="<?php echo _("Inbound Destination")?>">
        <p><span class="ui-icon ui-icon-alert" style="float:left; margin:12px 12px 20px 0;"></span><?php echo _("These items will be permanently deleted and cannot be recovered in the future. Do you want to proceed?")?></p>
    </div>

    <!-- диалог добавления -->
    <div id="add_inbound" class="dialog-form-module" title="<?php echo _("Inbound Destination")?>: <?php echo _("Add")?>">
        <div class="container-fluid">
            <div class="display full-border">
                <div class="row">
                    <div class="col-sm-12">
                        <div class="fpbx-container">
                            <div class="display full-border">

                                <!-- hide id when update form -->
                                <span class="update_did_form" style="display: none;" data-did-id=""></span>

                                <!--Description-->
                                <div class="element-container">
                                        <div class="row">
                                            <div class="col-md-12">
                                                <div class="row">
                                                    <div class="form-group">
                                                        <div class="col-md-3">
                                                            <label class="control-label" for="description"><?php echo _("Description")?></label>
                                                        </div>
                                                        <div class="col-md-9">
                                                            <input class="form-control" id="description" name="description" value="" type="text">
                                                        </div>
                                                    </div>
                                                </div>
                                            </div>
                                        </div>

                                </div>
                                <!--END Description-->
                                <!--User Portal-->
                                <div class="element-container">
                                    <div class="row">
                                        <div class="col-md-12">
                                            <div class="row">
                                                <div class="form-group">
                                                    <div class="col-md-4">
                                                        <label class="control-label" for="users-from-portal"><?php echo _("Default User")?></label>
                                                        <i class="fa fa-question-circle fpbx-help-icon" data-for="users-from-portal"></i>
                                                    </div>
                                                    <div class="col-md-8" data-placement="users-from-portal">
                                                        <div id="floatBarsG">
                                                            <div id="floatBarsG_1" class="floatBarsG"></div>
                                                            <div id="floatBarsG_2" class="floatBarsG"></div>
                                                            <div id="floatBarsG_3" class="floatBarsG"></div>
                                                            <div id="floatBarsG_4" class="floatBarsG"></div>
                                                            <div id="floatBarsG_5" class="floatBarsG"></div>
                                                            <div id="floatBarsG_6" class="floatBarsG"></div>
                                                            <div id="floatBarsG_7" class="floatBarsG"></div>
                                                            <div id="floatBarsG_8" class="floatBarsG"></div>
                                                        </div>
                                                    </div>
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                    <div class="row">
                                        <div class="col-md-12">
                                            <span id="users-from-portal-help" class="help-block fpbx-help-block"><?php echo _("manager, to whom the event is tied to, if the call was not answered and an incoming call was designated to none of other managers.");?></span>
                                        </div>
                                    </div>
                                </div>
                                <!--END User Portal-->
                                <!--Exclusions-->
                                <div class="element-container">
                                    <div class="row">
                                        <div class="col-md-12">
                                            <div class="row">
                                                <div class="form-group">
                                                    <div class="col-md-4">
                                                        <label class="control-label" for="exclusions-options"><?php echo _("Exceptions") ?></label>
                                                        <i class="fa fa-question-circle fpbx-help-icon" data-for="exclusions-options"></i>
                                                    </div>
                                                    <div class="col-md-8" data-placement="exclusions-options">

                                                        <select class="form-control" id="exclusions" name="exclusions">
                                                            <option value=""><?php echo _("Select") ?></option>
                                                            <?php foreach($exceptions as $exception):?>
                                                            <option value="<?php echo $exception['id']?>"><?php echo $exception['description']?></option>
                                                            <?php endforeach?>
                                                        </select>
                                                    </div>
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                    <div class="row">
                                        <div class="col-md-12">
                                            <span id="exclusions-options-help" class="help-block fpbx-help-block"><?php echo _("list of users that do not get assigned with calls and do not receive pop-up call cards (to configure the list, please see Exceptions tab in the upper bar).")?></span>
                                        </div>
                                    </div>
                                </div>
                                <!--END-Exclusions-->
                                <!--Show Caller Name-->
                                <div class="element-container">
                                    <div class="row">
                                        <div class="col-md-12">
                                            <div class="row">
                                                <div class="form-group">
                                                    <div class="col-md-4">
                                                        <label class="control-label" for="show_caller_name"><?php echo _("Show Caller Name")?></label>
                                                        <i class="fa fa-question-circle fpbx-help-icon" data-for="show_caller_name"></i>
                                                    </div>
                                                    <div class="col-md-8 radioset">
                                                        <input id="show_caller_name_yes_add" name="show_caller_name"  value="yes" type="radio">
                                                        <label for="show_caller_name_yes_add"><?php echo _("Yes")?></label>
                                                        <input id="show_caller_name_no_add" name="show_caller_name"  value="no" type="radio" checked="checked">
                                                        <label for="show_caller_name_no_add"><?php echo _("No")?></label>
                                                    </div>
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                    <div class="row">
                                        <div class="col-md-12">
                                            <span id="show_caller_name-help" class="help-block fpbx-help-block"><?php echo _("caller name will be displayed in the SIP phone/ softphone.");?></span>
                                        </div>
                                    </div>
                                </div>
                                <!--END Show Caller Name-->
                                <!-- Add To Chat -->
                                <div class="element-container">
                                    <div class="row">
                                        <div class="col-md-12">
                                            <div class="row">
                                                <div class="form-group">
                                                    <div class="col-md-4">
                                                        <label class="control-label" for="add_to_chat"><?php echo _("Add to chat")?></label>
                                                        <i class="fa fa-question-circle fpbx-help-icon" data-for="add_to_chat"></i>
                                                    </div>
                                                    <div class="col-md-8 radioset">
                                                        <input id="add_to_chat_no_add" name="add_to_chat"  value="No" type="radio" checked="checked">
                                                        <label for="add_to_chat_no_add"><?php echo _("No")?></label>
                                                        <input id="add_to_chat_answer_add" name="add_to_chat"  value="NoAnswered" type="radio">
                                                        <label for="add_to_chat_answer_add"><?php echo _("Unanswered")?></label>
                                                        <input id="add_to_chat_all_add" name="add_to_chat"  value="All" type="radio">
                                                        <label for="add_to_chat_all_add"><?php echo _("All")?></label>

                                                    </div>
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                    <div class="row">
                                        <div class="col-md-12">
                                            <span id="add_to_chat-help" class="help-block fpbx-help-block"><?php echo _("show calls in the chat list. No Answered — only unanswered calls, All — all calls.");?></span>
                                        </div>
                                    </div>
                                </div>
                                <!-- End Add To Chat -->
                                <!-- Assign to Unanswered Call-->
                                <div class="element-container">
                                    <div class="row">
                                        <div class="col-md-12">
                                            <div class="row">
                                                <div class="form-group">
                                                    <div class="col-md-4">
                                                        <label class="control-label" for="assign"><?php echo _("Assign to Unanswered Call")?></label>
                                                        <i class="fa fa-question-circle fpbx-help-icon" data-for="assign"></i>
                                                    </div>
                                                    <div class="col-md-8 radioset">
                                                        <input id="assign_default" name="assign"  value="default" type="radio" checked="checked">
                                                        <label for="assign_default"><?php echo _("Default User")?></label>
                                                        <input id="assign_manager" name="assign"  value="manager" type="radio">
                                                        <label for="assign_manager"><?php echo _("Assigned Manager")?></label>
                                                    </div>
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                    <div class="row">
                                        <div class="col-md-12">
                                            <span id="assign-help" class="help-block fpbx-help-block"><?php echo _("choose destination in case of a missed call — Default User or Assigned Manager.");?></span>
                                        </div>
                                    </div>
                                </div>
                                <!--END Assign to Unanswered Call-->
                                <!-- Tasks -->
                                <div class="element-container">
                                    <div class="row">
                                        <div class="col-md-12">
                                            <div class="row">
                                                <div class="form-group">
                                                    <div class="col-md-4">
                                                        <label class="control-label" for="did_tasks"><?php echo _("Create Task On Unanswered Call")?></label>
                                                        <i class="fa fa-question-circle fpbx-help-icon" data-for="did_tasks"></i>
                                                    </div>
                                                    <div class="col-md-8">
                                                        <?php if(!empty($tasks) && is_array($tasks)):?>
                                                        <select name="did_tasks" class="form-control did_tasks" id="did_tasks">
                                                            <option value="0"><?php echo _("Disabled")?></option>
                                                            <?php foreach($tasks as $task):?>
                                                            <option value="<?php echo $task['id']?>">
                                                                <?php echo $task['name']?>
                                                            </option>
                                                            <?php endforeach?>
                                                        </select>
                                                        <?php else:?>
                                                        <?php echo _("There are no available task templates.")?>
                                                        <?php endif;?>
                                                    </div>
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                    <div class="row">
                                        <div class="col-md-12">
                                            <span id="did_tasks-help" class="help-block fpbx-help-block"><?php echo _("this option allows to choose the necessary task form for missed calls.");?></span>
                                        </div>
                                    </div>
                                </div>
                                <!-- END Tasks -->
                                <!-- start show card -->
                                <div class="element-container">
                                    <div class="row">
                                        <div class="col-md-12">
                                            <div class="row">
                                                <div class="form-group">
                                                    <div class="col-md-4">
                                                        <label class="control-label" for="show_card"><?php echo _("Show Card")?></label>
                                                        <i class="fa fa-question-circle fpbx-help-icon" data-for="show_card"></i>
                                                    </div>
                                                    <div class="col-md-8 radioset">
                                                        <input id="show_card_yes_add" name="show_card"  value="yes" type="radio">
                                                        <label for="show_card_yes_add"><?php echo _("Yes")?></label>
                                                        <input id="show_card_no_add" name="show_card"  value="no" type="radio">
                                                        <label for="show_card_no_add"><?php echo _("No")?></label>
                                                    </div>
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                    <div class="row">
                                        <div class="col-md-12">
                                            <span id="show_card-help" class="help-block fpbx-help-block"><?php echo _("display call profile in Bitrix24.");?></span>
                                        </div>
                                    </div>
                                </div>
                                <!-- end show card -->
                                <div class="element-container">
                                    <div class="row">
                                        <div class="col-md-12">
                                            <div class="row">
                                                <div class="form-group">
                                                    <div class="col-md-4">
                                                        <label class="control-label" for="create_lead"><?php echo _("Create Lead")?></label>
                                                        <i class="fa fa-question-circle fpbx-help-icon" data-for="create_lead"></i>
                                                    </div>

                                                    <div class="col-md-8 radioset">
                                                        <input id="create_lead_yes_add" name="create_lead"  value="yes" type="radio">
                                                        <label for="create_lead_yes_add"><?php echo _("Yes")?></label>
                                                        <input id="create_lead_no_add" name="create_lead"  value="no" type="radio">
                                                        <label for="create_lead_no_add"><?php echo _("No")?></label>
                                                    </div>

                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                    <div class="row">
                                        <div class="col-md-12">
                                            <span id="create_lead-help" class="help-block fpbx-help-block"><?php echo _("create a new lead and deal.");?></span>
                                        </div>
                                    </div>
                                </div>
                                <!--Source-->
                                <div class="element-container">
                                    <div class="row">
                                        <div class="col-md-12">
                                            <div class="row">
                                                <div class="form-group">
                                                    <div class="col-md-4">
                                                        <label class="control-label" for="source-options"><?php echo _("Source") ?></label>
                                                        <i class="fa fa-question-circle fpbx-help-icon" data-for="source-options"></i>
                                                    </div>
                                                    <div class="col-md-8" data-placement="source-options">
                                                        <div id="floatBarsG">
                                                            <div id="floatBarsG_1" class="floatBarsG"></div>
                                                            <div id="floatBarsG_2" class="floatBarsG"></div>
                                                            <div id="floatBarsG_3" class="floatBarsG"></div>
                                                            <div id="floatBarsG_4" class="floatBarsG"></div>
                                                            <div id="floatBarsG_5" class="floatBarsG"></div>
                                                            <div id="floatBarsG_6" class="floatBarsG"></div>
                                                            <div id="floatBarsG_7" class="floatBarsG"></div>
                                                            <div id="floatBarsG_8" class="floatBarsG"></div>
                                                        </div>
                                                        <select class="form-control" id="source" name="source">

                                                        </select>
                                                    </div>
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                    <div class="row">
                                        <div class="col-md-12">
                                            <span id="source-options-help" class="help-block fpbx-help-block"><?php echo _("call source is taken from Bitrix24. It does not affect the call routing.");?></span>
                                        </div>
                                    </div>
                                </div>
                                <!--END-Source-->
                                <!--Manager-->
                                <div class="element-container">
                                    <div class="row">
                                        <div class="col-md-12">
                                            <div class="row">
                                                <div class="col-md-12">
                                                    <div class="row">
                                                        <div class="form-group">
                                                            <div class="col-md-4">
                                                                <label class="control-label" for="consider_manager"><?php echo _("Destination for registered callers")?></label>
                                                                <i class="fa fa-question-circle fpbx-help-icon" data-for="consider_manager"></i>
                                                            </div>
                                                            <div class="col-md-3">
                                                                <?php echo drawselects((isset($item['dest']) ? $item['dest'] : "manager_in_charge,exit"),1, array("informunity_bitrix24"=>array("manager_in_charge"),"core" => array("extensions"), "ivr", "queues","ringgroups","timeconditions"), true, '', false, false, true, false, 'consider_manager')?>
                                                            </div>
                                                            <div hidden class="element-container show_div_ringtimer">
                                                                <div class="col-md-3">
                                                                    <label class="control-label" for="assigned_manager_ring_timer"><?php echo _("Ring Time")?></label>
                                                                </div>
                                                                <div class="col-md-3">
                                                                    <input class="form-control" id="assigned_manager_ring_timer" name="assigned_manager_ring_timer" value="" type="text">
                                                                </div>
                                                            </div>
                                                        </div>
                                                    </div>
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                    <div class="row">
                                        <div class="col-md-12">
                                            <span id="consider_manager-help" class="help-block fpbx-help-block"><?php echo _("if “Extension” is selected the call will be redirected to manager responsible for lead or contact with the current call number, if “Extension&Mobile” is selected, manager will receive the call to mobile phone if he doesn’t take the internal call.<br>When choosing a queue, a ring group or an IVR, the call follows Failover Destination of the listed modules.");?></span>
                                        </div>
                                    </div>
                                </div>
                                <!--END Manager-->
                                <!--Assessment-->
                                <div class="element-container">
                                    <div class="row">
                                        <div class="col-md-12">
                                            <div class="row">
                                                <div class="form-group">
                                                    <div class="col-md-4">
                                                        <label class="control-label" for="callrecording_mode"><?php echo _("Service Quality Assessment")?></label>
                                                        <i class="fa fa-question-circle fpbx-help-icon" data-for="callrecording_mode"></i>
                                                    </div>
                                                    <div class="col-md-8 radioset">
                                                        <input id="record_yes" name="callrecording_mode" value="yes" type="radio">
                                                        <label for="record_yes"><?php echo _("Yes")?></label>
                                                        <input id="record_no" name="callrecording_mode" value="no" type="radio" checked="checked">
                                                        <label for="record_no"><?php echo _("No")?></label>
                                                    </div>
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                    <div class="row">
                                        <div class="col-md-12">
                                            <span id="callrecording_mode-help" class="help-block fpbx-help-block"><?php echo _("upon the call client will be offered to assess quality of service by pressing button (0–5) at the phone.");?></span>
                                        </div>
                                    </div>
                                </div>
                                <!--END Assessment-->
                                <!--Initial Message-->
                                <div class="element-container show_div_greet" style="display: none;">
                                    <div class="row">
                                        <div class="col-md-12">
                                            <div class="row">
                                                <div class="form-group">
                                                    <div class="col-md-4">
                                                        <label class="control-label" for="greatings"><?php echo _("Initial message") ?></label>
                                                        <i class="fa fa-question-circle fpbx-help-icon" data-for="greatings"></i>
                                                    </div>
                                                    <div class="col-md-8">
                                                        <select class="form-control" id="greatings" name="greatings">
                                                            <?php echo $greatings?>
                                                        </select>
                                                    </div>
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                    <div class="row">
                                        <div class="col-md-12">
                                            <span id="greatings-help" class="help-block fpbx-help-block"><?php echo _("voice greeting before assessment.");?></span>
                                        </div>
                                    </div>
                                </div>
                                <!--END Initial Message-->
                                <!--Finish Message-->
                                <div class="element-container show_div_bye" style="display: none;">
                                    <div class="row">
                                        <div class="col-md-12">
                                            <div class="row">
                                                <div class="form-group">
                                                    <div class="col-md-4">
                                                        <label class="control-label" for="bye"><?php echo _("Final message") ?></label>
                                                        <i class="fa fa-question-circle fpbx-help-icon" data-for="bye"></i>
                                                    </div>
                                                    <div class="col-md-8">
                                                        <select class="form-control" id="bye" name="bye">
                                                            <?php echo $bye?>
                                                        </select>
                                                    </div>
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                    <div class="row">
                                        <div class="col-md-12">
                                            <span id="bye-help" class="help-block fpbx-help-block"><?php echo _("voice message after assessment.");?></span>
                                        </div>
                                    </div>
                                </div>
                                <!--END Finish Message-->
                                <!--Destination-->
                                <div class="element-container">
                                    <div class="row">
                                        <div class="col-md-12">
                                            <div class="row">
                                                <div class="form-group">
                                                    <div class="col-md-4">
                                                        <label class="control-label" for="dest_ajax"><?php echo _("Destination")?></label>
                                                        <i class="fa fa-question-circle fpbx-help-icon" data-for="dest_ajax"></i>
                                                    </div>
                                                    <div class="col-md-8">
                                                        <div class="dest_ajax"><?php echo drawselect_inbound_dest()?></div>
                                                    </div>
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                    <div class="row">
                                        <div class="col-md-12">
                                            <span id="dest_ajax-help" class="help-block fpbx-help-block"><?php echo _("call destination.");?></span>
                                        </div>
                                    </div>
                                </div>
                                <!--END Destination-->
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>

    <!-- event list callstart-->
    <div id="list_b24_events_ONEXTERNALCALLSTART" class="dialog-form-module">
        <div class="container-fluid">
            <div class="display full-border">
                <div class="row">
                    <div class="col-sm-12">
                        <div class="fpbx-container">
                            <div class="display full-border list-events-items">
                                <?php if($autorized):?>
                                    <table id="event-list-callstart" data-url="ajax.php?module=informunity_bitrix24&amp;command=isEventRegister&event=ONEXTERNALCALLSTART" data-cache="false" data-maintain-selected="true" data-toggle="table" data-pagination="true" data-search="true" class="table table-striped">
                                        <thead>
                                        <tr>
                                            <th data-field="eventCode"><?=_("Event")?></th>
                                            <th data-field="handler"><?=_("Handler")?></th>
                                            <th data-field="actions" class="col-xs-2"><?php echo _("Actions")?></th>
                                        </tr>
                                        </thead>
                                    </table>
                                <?php endif?>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>

    <!-- list events callbackstart-->
    <div id="list_b24_events_ONEXTERNALCALLBACKSTART" class="dialog-form-module">
        <div class="container-fluid">
            <div class="display full-border">
                <div class="row">
                    <div class="col-sm-12">
                        <div class="fpbx-container">
                            <div class="display full-border list-events-items">
                                <?php if($autorized):?>
                                    <table id="event-list-callstart" data-url="ajax.php?module=informunity_bitrix24&amp;command=isEventRegister&event=ONEXTERNALCALLBACKSTART" data-cache="false" data-maintain-selected="true" data-toggle="table" data-pagination="true" data-search="true" class="table table-striped">
                                        <thead>
                                        <tr>
                                            <th data-field="eventCode"><?=_("Event")?></th>
                                            <th data-field="handler"><?=_("Handler")?></th>
                                            <th data-field="actions" class="col-xs-2"><?php echo _("Actions")?></th>
                                        </tr>
                                        </thead>
                                    </table>
                                <?php endif?>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>

    <!-- диалог проверки совместимости softphone -->
    <div id="check_softphone_compability" class="dialog-form-module" title="<?=_('Check Compability')?>">
        <div class="container-fluid">
            <div class="display full-border">
                <div class="row">
                    <div class="col-sm-12">
                        <div class="fpbx-container">
                            <div class="display full-border">

                                <!--miniHttpsServ-->
                                <div class="element-container">
                                    <div class="row">
                                        <div class="col-md-12">
                                            <div class="row">
                                                <div class="form-group">
                                                    <div class="col-md-3">
                                                        <label class="control-label" for="miniHttpsServ"><?php echo _("mini-HTTP Server")?></label>
                                                    </div>
                                                    <div class="col-md-9 radioset">
                                                        <input type="radio" name="miniHttpsServ"
                                                        id="miniHttpsServYes" value="yes" >
                                                        <label for="miniHttpsServYes" id="label_yes"><?php echo _("Yes");?></label>

                                                        <input type="radio"  name="miniHttpsServ"
                                                        id="miniHttpsServNo" value="yes" >
                                                        <label for="miniHttpsServNo" id="label_no"><?php echo _("No");?></label>
                                                    </div>
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                                <!--END miniHttpsServ-->

                                <!--TLS for the mini-HTTP Server-->
                                <div class="element-container">
                                    <div class="row">
                                        <div class="col-md-12">
                                            <div class="row">
                                                <div class="form-group">
                                                    <div class="col-md-3">
                                                        <label class="control-label" for="TLSminiServ"><?php echo _("TLS for the mini-HTTP Server")?></label>
                                                    </div>
                                                    <div class="col-md-9 radioset">
                                                        <input type="radio" name="TLSminiServ"
                                                        id="TLSminiServYes" value="yes" >
                                                        <label for="TLSminiServYes" id="label_yes"><?php echo _("Yes");?></label>

                                                        <input type="radio"  name="TLSminiServ"
                                                        id="TLSminiServNo" value="yes" >
                                                        <label for="TLSminiServNo" id="label_no"><?php echo _("No");?></label>
                                                    </div>
                                                    
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                                <!--END TLS for the mini-HTTP Server-->

                                <!--Certificate configuration-->
                                <div class="element-container">
                                    <div class="row">
                                        <div class="col-md-12">
                                            <div class="row">
                                                <div class="form-group">
                                                    <div class="col-md-3">
                                                        <label class="control-label" for="configSertificate"><?php echo _("Certificate configuration")?></label>
                                                    </div>
                                                    <div class="col-md-9 radioset">
                                                        <input type="radio" name="configSertificate"
                                                        id="configSertificateYes" value="yes" >
                                                        <label for="configSertificateYes" id="label_yes"><?php echo _("Yes");?></label>

                                                        <input type="radio"  name="configSertificate"
                                                        id="configSertificateNo" value="yes" >
                                                        <label for="configSertificateNo" id="label_no"><?php echo _("No");?></label>
                                                    </div>
                                                    
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                                <!--END Certificate configuration-->

                                <!--External WSS Port-->
                                <div class="element-container">
                                    <div class="row">
                                        <div class="col-md-12">
                                            <div class="row">
                                                <div class="form-group">
                                                    <div class="col-md-3">
                                                        <label class="control-label" for="externalWSSPort"><?php echo _("External WSS Port")?></label>
                                                    </div>
                                                    <div class="col-md-6">
                                                        <input class="form-control" placeholder="<?=$externalWssPort?>" id="externalWSSPort" name="externalWSSPort" value="" type="input">
                                                        
                                                    </div>
                                                    <div class="col-md-3">
                                                        <div class="ui-dialog-buttonset">
                                                                <input type="button" value="<?=_('Save')?>" data-bind="save_softphone_port">
                                                                
                                                        </div>
                                                    </div>
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                                <!--END External WSS Port-->

                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
    <!-- end softphone compability dialog -->

    <div id="add_lines" class="dialog-form-module" title="<?php echo _("Line")?>: <?php echo _("Add")?>">
        <div class="container-fluid">
            <div class="display full-border">
                <div class="row">
                    <div class="col-sm-12">
                        <div class="fpbx-container">
                            <div class="display full-border">

                                <!--DID-->
                                <div class="element-container">
                                    <div class="row">
                                        <div class="col-md-12">
                                            <div class="row">
                                                <div class="form-group">
                                                    <div class="col-md-3">
                                                        <label class="control-label" for="did"><?php echo _("DID")?></label>
                                                    </div>
                                                    <div class="col-md-9">
                                                        <input class="form-control" id="did" name="did" value="" type="text">
                                                    </div>
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                                <!--END DID-->

                                <!--Number-->
                                <div class="element-container">
                                    <div class="row">
                                        <div class="col-md-12">
                                            <div class="row">
                                                <div class="form-group">
                                                    <div class="col-md-3">
                                                        <label class="control-label" for="number"><?php echo _("Number")?></label>
                                                    </div>
                                                    <div class="col-md-9">
                                                        <input class="form-control" id="number" name="number" value="" type="text">
                                                    </div>
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                                <!--END Number-->

                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>

    <!-- диалог удаления линии с подтверждением-->
    <div id="delete_line" title="Line Route ID">
        <p>
            <span class="ui-icon ui-icon-alert" style="float:left; margin:12px 12px 20px 0;"></span>
            <?php echo _("These items will be permanently deleted and cannot be recovered in the future. Do you want to proceed?")?>
        </p>
    </div>

    <div id="update_lines" class="dialog-form-module" title="<?php echo _("Line")?>: <?php echo _("Update")?>">
        <div class="container-fluid">
            <div class="display full-border">
                <div class="row">
                    <div class="col-sm-12">
                        <div class="fpbx-container">
                            <div class="display full-border">

                                <span class="update_line_form" style="display: none;" data-line-id=""></span>
                                <!--DID-->
                                <div class="element-container">
                                    <div class="row">
                                        <div class="col-md-12">
                                            <div class="row">
                                                <div class="form-group">
                                                    <div class="col-md-3">
                                                        <label class="control-label" for="did"><?php echo _("DID")?></label>
                                                    </div>
                                                    <div class="col-md-9">
                                                        <input class="form-control" id="did" name="did" value="" type="text">
                                                    </div>
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                                <!--END DID-->

                                <!--Number-->
                                <div class="element-container">
                                    <div class="row">
                                        <div class="col-md-12">
                                            <div class="row">
                                                <div class="form-group">
                                                    <div class="col-md-3">
                                                        <label class="control-label" for="number"><?php echo _("Number")?></label>
                                                    </div>
                                                    <div class="col-md-9">
                                                        <input class="form-control" id="number" name="number" value="" type="text">
                                                    </div>
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                                <!--END Number-->

                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>

    <!-- диалог добавления exceptions -->
    <div id="add_exception" class="dialog-form-module" title="<?php echo _("Exception")?>: <?php echo _("Add")?> ">
        <div class="container-fluid">
            <div class="display full-border">
                <div class="row">
                    <div class="col-sm-12">
                        <div class="fpbx-container">
                            <div class="display full-border">

                                <!-- Название -->
                                <div class="element-container">
                                    <div class="row">
                                        <div class="col-md-12">
                                            <div class="row">
                                                <div class="form-group">
                                                    <div class="col-md-3">
                                                        <label class="control-label" for="description"><?php echo _("Description")?></label>
                                                    </div>
                                                    <div class="col-md-9">
                                                        <input class="form-control" id="description" name="description" value="" type="text">
                                                    </div>
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                                <!--END Название-->

                                <!-- numbers -->
                                <div class="element-container">
                                    <div class="row">
                                        <div class="col-md-12">
                                            <div class="row">
                                                <div class="form-group" data-template="first_number_exception">
                                                    <div class="col-md-3">
                                                        <label class="control-label" for="numbers" data-name="numbers"><?php echo _("Members")?></label>
                                                        <button type="button" data-bind="del-number" class="ui-button ui-widget ui-state-default ui-corner-all ui-button-icon-only ui-dialog-titlebar-close iu-icon-delete-user hidden margin-style-delete-main" role="button">
                                                            <span class="ui-button-icon-primary ui-icon ui-icon-closethick"></span>
                                                        </button>
                                                    </div>
                                                    <div class="col-md-9" data-observ="numbers-list">
                                                        
                                                    </div>

                                                    <div class="col-md-3 add_number_exc" id="add_number_exc"></div>
                                                    <div class="col-md-9" data-action="number_add_exc">
                                                        <input type="button" id="add_numbers_button" value="<?php echo _('Add')?>">
                                                    </div>
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                                <!--END numbers-->

                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
    <!-- End exceptions add -->

    <!-- диалог добавления задачи -->
    <div id="add_task" class="dialog-form-module" title="<?php echo _("Task")?>: <?php echo _("Add")?> <?php echo _("template")?>">
        <div class="container-fluid">
            <div class="display full-border">
                <div class="row">
                    <div class="col-sm-12">
                        <div class="fpbx-container">
                            <div class="display full-border">

                                <!-- Название -->
                                <div class="element-container">
                                    <div class="row">
                                        <div class="col-md-12">
                                            <div class="row">
                                                <div class="form-group">
                                                    <div class="col-md-3">
                                                        <label class="control-label" for="task_name"><?php echo _("Task name")?></label>
                                                    </div>
                                                    <div class="col-md-9">
                                                        <input class="form-control" id="task_name" name="task_name" value="" type="text">
                                                    </div>
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                                <!--END Название-->

                                <!-- Наблюдатели -->
                                <div class="element-container">
                                    <div class="row">
                                        <div class="col-md-12">
                                            <div class="row">
                                                <div class="form-group" data-template="first_user">
                                                    <div class="col-md-3">
                                                        <label class="control-label" for="observers" data-name="observers"><?php echo _("Observers")?></label>
                                                        <button type="button" data-bind="del-obs" class="ui-button ui-widget ui-state-default ui-corner-all ui-button-icon-only ui-dialog-titlebar-close iu-icon-delete-user hidden margin-style-delete-main" role="button">
                                                            <span class="ui-button-icon-primary ui-icon ui-icon-closethick"></span>
                                                        </button>
                                                    </div>
                                                    <div class="col-md-9" data-observ="observers-list">
                                                        
                                                    </div>

                                                    <div class="col-md-3 add_observer" id="add_observers"></div>
                                                    <div class="col-md-9" data-action="user_add">
                                                        <input type="button" id="add_observers_button" value="<?php echo _('Add')?>">
                                                    </div>
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                                <!--END Наблюдатели-->

                                <!-- Крайний срок -->
                                <div class="element-container">
                                    <div class="row">
                                        <div class="col-md-12">
                                            <div class="row">
                                                <div class="form-group">
                                                    <div class="col-md-3">
                                                        <label class="control-label" for="deadline"><?php echo _("Deadline")?></label>
                                                    </div>
                                                    <div class="col-md-6">
                                                        <input class="form-control" id="deadline" name="deadline" value="" type="text">
                                                    </div>
                                                    <div class="col-md-3">
                                                        <select id="hour_day" name="hour_day" class="form-control">
                                                            <option value="<?php echo _('Hour')?>" selected>
                                                                <?php echo _('Hour')?>
                                                            </option>
                                                            <option value="<?php echo _('Day')?>">
                                                                <?php echo _('Day')?>
                                                            </option>
                                                        </select>
                                                    </div>
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                                <!--END Крайний срок-->

                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>

    <!-- диалог удаления задачи с подтверждением-->
    <div id="delete_task" title="<?php echo _('Task')?>">
        <p>
            <span class="ui-icon ui-icon-alert" style="float:left; margin:12px 12px 20px 0;"></span>
            <?php echo _("These items will be permanently deleted and cannot be recovered in the future. Do you want to proceed?")?>
        </p>
    </div>

    <!-- диалог изменения задачи -->
    <div id="update_task" class="dialog-form-module" title="<?php echo _("Task")?>: <?php echo _("Update")?> <?php echo _("template")?>">
        <div class="container-fluid">
            <div class="display full-border">
                <div class="row">
                    <div class="col-sm-12">
                        <div class="fpbx-container">
                            <div class="display full-border">

                                <span class="update_task_form" style="display: none;" data-task-id=""></span>

                                <!-- Название -->
                                <div class="element-container">
                                    <div class="row">
                                        <div class="col-md-12">
                                            <div class="row">
                                                <div class="form-group">
                                                    <div class="col-md-3">
                                                        <label class="control-label" for="task_name"><?php echo _("Task name")?></label>
                                                    </div>
                                                    <div class="col-md-9">
                                                        <input class="form-control" id="task_name" name="task_name" value="" type="text">
                                                    </div>
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                                <!--END Название-->

                                <!-- Наблюдатели -->
                                <div class="element-container">
                                    <div class="row">
                                        <div class="col-md-12">
                                            <div class="row">
                                                <div class="form-group" data-name="update_observ">
                                                    <div class="col-md-3 obs_update" id="obs_update"></div>
                                                    <div class="col-md-9">
                                                        <input type="button" id="observers_update_button" value="<?php echo _('Add')?>">
                                                    </div>
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                                <!--END Наблюдатели-->

                                <!-- Крайний срок -->
                                <div class="element-container">
                                    <div class="row">
                                        <div class="col-md-12">
                                            <div class="row">
                                                <div class="form-group">
                                                    <div class="col-md-3">
                                                        <label class="control-label" for="deadline"><?php echo _("Deadline")?></label>
                                                    </div>
                                                    <div class="col-md-6">
                                                        <input class="form-control" id="deadline" name="deadline" value="" type="text">
                                                    </div>
                                                    <div class="col-md-3">
                                                        <select id="hour_day" name="hour_day" class="form-control">
                                                            <option value="<?php echo _('Hour')?>">
                                                                <?php echo _('Hour')?>
                                                            </option>
                                                            <option value="<?php echo _('Day')?>">
                                                                <?php echo _('Day')?>
                                                            </option>
                                                        </select>
                                                    </div>
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                                <!--END Крайний срок-->
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>

    <!-- Диалог изменения exception -->
    <div id="update_exception" class="dialog-form-module" title="<?php echo _("Exception")?>: <?php echo _("Update")?> ">
        <div class="container-fluid">
            <div class="display full-border">
                <div class="row">
                    <div class="col-sm-12">
                        <div class="fpbx-container">
                            <div class="display full-border">

                                <span class="update_exception_form" style="display: none;" data-exception-id=""></span>

                                <!-- Название -->
                                <div class="element-container">
                                    <div class="row">
                                        <div class="col-md-12">
                                            <div class="row">
                                                <div class="form-group">
                                                    <div class="col-md-3">
                                                        <label class="control-label" for="description"><?php echo _("Description")?></label>
                                                    </div>
                                                    <div class="col-md-9">
                                                        <input class="form-control" id="description" name="description" value="" type="text">
                                                    </div>
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                                <!--END Название-->

                                <!-- numbers -->
                                <div class="element-container">
                                    <div class="row">
                                        <div class="col-md-12">
                                            <div class="row">
                                                <div class="form-group" data-name="update_observ_num">
                                                    <div class="col-md-3 numb_update" id="numb_update"></div>
                                                    <div class="col-md-9">
                                                        <input type="button" id="numbers_update_button" value="<?php echo _('Add')?>">
                                                    </div>
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                                <!--END numbers -->

                                
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
    <!-- End exception edit dialog -->

</div>


<script type="text/javascript">
    var destinations = <?php echo json_encode(FreePBX::Modules()->getDestinations())?>;
    function DIDnumberFormatter(value){
        if(value.length == 0){
            return _("Any");
        }else{
            return decodeURIComponent(value);
        }
    }
    function DIDdestFormatter(value){
        if(value === null || value.length == 0){
            return _("No Destination");
        }else{
            if(typeof destinations[value] !== "undefined") {
                var prefix = destinations[value].name;
                if(typeof destinations[value].category !== "undefined"){
                    prefix = destinations[value].category;
                }
                if(typeof destinations[value].edit_url !== "undefined" && destinations[value].edit_url !== false) {
                    return '<a href="' + destinations[value].edit_url + '">' + prefix + ": " + destinations[value].description + '</a>';
                } else {
                    return prefix + ": " + destinations[value].description;
                }
            } else {
                return value;
            }
        }
    }
    function DIDlinkFormatter(value, row){
        var html = '<a href="?display=did&view=form&extdisplay='+row['extension']+'%2F'+row['cidnum']+'"><i class="fa fa-edit"></i></a>';
        html += '&nbsp;<a href="?display=did&action=delIncoming&didfilter=&rnavsort=&extdisplay='+row['extension']+'%2F'+row['cidnum']+'" class="delAction"><i class="fa fa-trash"></i></a>';
        return html;
    }
</script>