<div class="modal fade in" id="oobe_dialog" role="dialog" style="display: block; padding-right: 17px; padding-top: 17px;">
    <div class="modal-dialog-lg" role="document">

        <div class="col-md-10 col-md-offset-1 modal-content pre-scrollable" style="max-height: 100vh; overflow: auto;">
            <div class="container-fluid">

                <div class="fpbx-container">
                    <div class="row">
                        <div class="text-center h1 modal-title">
                            InformUnity Bitrix24
                        </div>
                    </div>
                </div>

                <div class="fpbx-container swMain">

                    <div class="row">

                        <div class="text-center alert panel-success h3">
                            <?php echo _("You just updated the module to version")?> <?php echo $version ?> !
                        </div>


                        <div class="panel panel-danger alert-danger" style="box-shadow: lightgrey 5px 5px 15px;">
                            <div class="panel-heading">

                                <h3 class="panel-title "><a class="glyphicon glyphicon-info-sign"></a>  <?php echo _("Starting from 14.0.0.1, we have changed the network configurations")?>
                                    :</h3>
                            </div>
                            <div class="panel-body">
                                <?php echo _("- To simplify the diagnostic process, now all requests for calls from the portal go through our licensed server (thus we make sure you can diagnose network settings all by yourself). The diagnostics goes automatically and you will see the errors displayed as banners.")?>
                                <br>
                                <?php echo _("Please update the network configurations according to the")?> <a
                                        target="_blank"
                                        href="https://www.bitrix24.<?php echo _('com')?>/apps/?app=informunity.fpbx#install"><?php echo _("instruction")?></a> <?php echo _("and re-register the handlers")?>
                                .<br>
                            </div>

                        </div>

                        <div class="panel panel-info alert-info" style="box-shadow: lightgrey 5px 5px 15px;">

                            <div class="panel-heading">
                                <h3 class="panel-title"><?php echo _("New features")?>:<br></h3
                                        :</h3>
                            </div>
                            <div class="panel-body">
                                <?php echo _("- Now, when two or more telephony servers are connected to a single Bitrix24, it is possible to send call requests to the Asterisk with the employee's internal number")?>
                                .<br>
                                <?php echo _("- The Exceptions tab allows you to create lists of users who are not supposed to participate in the calling process")?>
                                ;<br>
                                <?php echo _("- At the Bitrix24 Handlers tab you can identify all currently registered handlers and remove unnecessary ones")?>
                                ;<br>
                                <?php echo _("- Now you can see the license status at the Registration Data tab")?>;<br>
                                <?php echo _("- If a lead or a deal have been created as a result of the current call, the created entity gets assigned to the person who is talking on the phone at the moment, and this responsible person can make changes to the created entity right during the conversation (before he hangs up or transfers the call)")?>
                                .<br>
                            </div>

                        </div>
                        <div class="col-md-6">
                            <div class=" panel panel-info" style="box-shadow: lightgrey 5px 5px 15px;">
                                <div id="myCarousel" class="carousel slide" data-ride="carousel">
                                    <!-- Indicators -->
                                    <ol class="carousel-indicators">
                                        <li data-target="#myCarousel" data-slide-to="0" class="active"></li>
                                        <li data-target="#myCarousel" data-slide-to="1"></li>
                                    </ol>

                                    <!-- Wrapper for slides -->
                                    <div class="carousel-inner" style="border-radius: 5px" role="listbox">
                                        <div class="item active">
                                            <img src="modules/informunity_bitrix24/images/RegData.png">
                                        </div>
                                        <div class="item">
                                            <img src="modules/informunity_bitrix24/images//Handlers.png">
                                        </div>
                                        <div class="item">
                                            <img src="modules/informunity_bitrix24/images/Exceptions.png">
                                        </div>
                                    </div>

                                    <!-- Left and right controls -->
                                    <a class="left carousel-control" style="background-image: none" href="#myCarousel" data-slide="prev">
                                        <span class="glyphicon glyphicon-chevron-left"></span>
                                    </a>
                                    <a class="right carousel-control" style="background-image: none" href="#myCarousel" data-slide="next">
                                        <span class="glyphicon glyphicon-chevron-right"></span>
                                    </a>
                                </div>
                            </div>
                        </div>
                        <div class="col-md-5 pull-right">
                            <div class="panel panel-default" style="box-shadow: lightgrey 5px 5px 15px;">
                                <div class="panel-heading">
                                    <h3 class="panel-title">ChangeLog</h3>
                                </div>
                                <div class="panel-body">
                                    <?php echo implode("\r",$changelog)?>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
                <div class="fpbx-container modal-footer">
                    <div class="row">
                        <div class="submit-button row text-center">
                            <form method='post' id='obbe_Notice'>
                                <button class='btn btn-primary' type='submit' name='complete'><?php echo _("Accept")?></button>
                            </form>
                        </div>
                    </div>
                </div>

            </div>
        </div>
    </div>
</div>